
(******************************************************************************
  Apache portable runtime API for FreePascal

  Note: I'm expect what it is very buggy... be careful ;)

  Zolotov Alex, 2007-2008
  zolotov-alex@shamangrad.net
  http://shamangrad.net/

 *****************************************************************************)

type
  { Many applications use the type member to determine the
   * existance of a file or initialization of the file info,
   * so the APR_NOFILE value must be distinct from APR_UNKFILE.
    }
  {* apr_filetype_e values for the filetype member of the 
   * apr_file_info_t structure
   * @warning: Not all of the filetypes below can be determined.
   * For example, a given platform might not correctly report 
   * a socket descriptor as APR_SOCK if that type isn't 
   * well-identified on that platform.  In such cases where
   * a filetype exists but cannot be described by the recognized
   * flags below, the filetype will be APR_UNKFILE.  If the
   * filetype member is not determined, the type will be APR_NOFILE.
    }
  apr_filetype_e = (
    {* no file type determined  }
    APR_NOFILE := 0,
    {* a regular file  }
    APR_REG,
    {* a directory  }
    APR_DIR,
    {* a character device  }
    APR_CHR,
    {* a block device  }
    APR_BLK,
    {* a FIFO / pipe  }
    APR_PIPE,
    {* a symbolic link  }
    APR_LNK,
    {* a [unix domain] socket  }
    APR_SOCK,
    {* a file of some other unknown type  }
    APR_UNKFILE := 127
  );
  
  {*
   * @defgroup apr_file_permissions File Permissions flags 
   * @
    }
  {*< Set user id  }

  const
     APR_USETID = $8000;       {*< Read by user  }
     APR_UREAD = $0400;       {*< Write by user  }
     APR_UWRITE = $0200;       {*< Execute by user  }
     APR_UEXECUTE = $0100;       {*< Set group id  }
     APR_GSETID = $4000;       {*< Read by group  }
     APR_GREAD = $0040;       {*< Write by group  }
     APR_GWRITE = $0020;       {*< Execute by group  }
     APR_GEXECUTE = $0010;       {*< Sticky bit  }
     APR_WSTICKY = $2000;       {*< Read by others  }
     APR_WREAD = $0004;       {*< Write by others  }
     APR_WWRITE = $0002;       {*< Execute by others  }
     APR_WEXECUTE = $0001;       {*< use OS's default permissions  }
     APR_OS_DEFAULT = $0FFF;       { additional permission flags for apr_file_copy  and apr_file_append  }
  {*< Copy source file's permissions  }
     APR_FILE_SOURCE_PERMS = $1000;     
  {* @  }
  {*
   * Structure for referencing directories.
    }
type
  apr_dir_p = ^apr_dir_t;
  apr_dir_t = record end;
  
  {*
   * Structure for determining file permissions.
    }

     apr_fileperms_t = apr_int32_t;
{$if defined(WIN32) OR defined(NETWARE)}
  {*
   * Structure for determining the inode of the file.
    }

  type

     apr_ino_t = apr_uint64_t;
  {*
   * Structure for determining the device the file is on.
    }

     apr_dev_t = apr_uint32_t;
{$else}
  {* The inode of the file.  }

  type

     apr_ino_t = ino_t;
  {*
   * Structure for determining the device the file is on.
    }

     apr_dev_t = dev_t;
{$endif}
  {*
   * @defgroup apr_file_stat Stat Functions
   * @
    }
  {* file info structure  }


  const
     APR_FINFO_LINK = $00000001;       {*< Modification Time  }
     APR_FINFO_MTIME = $00000010;      {*< Creation Time  }
     APR_FINFO_CTIME = $00000020;      {*< Access Time  }
     APR_FINFO_ATIME = $00000040;      {*< Size of the file  }
     APR_FINFO_SIZE = $00000100;       {*< Storage size consumed by the file  }
     APR_FINFO_CSIZE = $00000200;      {*< Device  }
     APR_FINFO_DEV = $00001000;       {*< Inode  }
     APR_FINFO_INODE = $00002000;       {*< Number of links  }
     APR_FINFO_NLINK = $00004000;       {*< Type  }
     APR_FINFO_TYPE = $00008000;       {*< User  }
     APR_FINFO_USER = $00010000;       {*< Group  }
     APR_FINFO_GROUP = $00020000;       {*< User protection bits  }
     APR_FINFO_UPROT = $00100000;       {*< Group protection bits  }
     APR_FINFO_GPROT = $00200000;       {*< World protection bits  }
     APR_FINFO_WPROT = $00400000;       {*< if dev is case insensitive  }
     APR_FINFO_ICASE = $01000000;       {*< ->name in proper case  }
     APR_FINFO_NAME = $02000000;       {*< type, mtime, ctime, atime, size  }
     APR_FINFO_MIN = $00008170;       {*< dev and inode  }
     APR_FINFO_IDENT = $00003000;       {*< user and group  }
     APR_FINFO_OWNER = $00030000;       {*<  all protections  }
     APR_FINFO_PROT = $00700000;       {*<  an atomic unix apr_stat()  }
     APR_FINFO_NORM = $0073b170;       {*<  an atomic unix apr_dir_read()  }
     APR_FINFO_DIRENT = $02000000;
  {*
   * The file information structure.  This is analogous to the POSIX
   * stat structure.
    }
  {* Allocates memory and closes lingering handles in the specified pool  }
  {* The bitmask describing valid fields of this apr_finfo_t structure 
       *  including all available 'wanted' fields and potentially more  }
  {* The access permissions of the file.  Mimics Unix access rights.  }
  {* The type of file.  One of APR_REG, APR_DIR, APR_CHR, APR_BLK, APR_PIPE, 
       * APR_LNK or APR_SOCK.  If the type is undetermined, the value is APR_NOFILE.
       * If the type cannot be determined, the value is APR_UNKFILE.
        }
  {* The user id that owns the file  }
  {* The group id that owns the file  }
  {* The inode of the file.  }
  {* The id of the device the file is on.  }
  {* The number of hard links to the file.  }
  {* The size of the file  }
  {* The storage size consumed by the file  }
  {* The time the file was last accessed  }
  {* The time the file was last modified  }
  {* The time the file was last changed  }
  {* The pathname of the file (possibly unrooted)  }
(* Const before type ignored *)
  {* The file's name (no path) in filesystem case  }
(* Const before type ignored *)
  {* The file's handle, if accessed (can be submitted to apr_duphandle)  }

type
  apr_finfo_p = ^apr_finfo_t;
  apr_finfo_t = record
    pool: apr_pool_p;
    valid: apr_int32_t;
    protection: apr_fileperms_t;
    filetype: apr_filetype_e;
    user: apr_uid_t;
    group: apr_gid_t;
    inode: apr_ino_t;
    device: apr_dev_t;
    nlink: apr_int32_t;
    size: apr_off_t;
    csize: apr_off_t;
    atime: apr_time_t;
    mtime: apr_time_t;
    ctime: apr_time_t;
    fname: pchar;
    name: pchar;
    filehand: apr_file_p;
  end;

  {*
   * get the specified file's stats.  The file is specified by filename, 
   * instead of using a pre-opened file.
   * @param finfo Where to store the information about the file, which is
   * never touched if the call fails.
   * @param fname The name of the file to stat.
   * @param wanted The desired apr_finfo_t fields, as a bit flag of APR_FINFO_ values 
   * @param cont the pool to use to allocate the new file. 
    }

function apr_stat(finfo: apr_finfo_p; fname: pchar; wanted: apr_int32_t; cont: apr_pool_p): apr_status_t; cdecl; external libapr name 'apr_stat';

  {*
   * get the specified file's stats.  The file is specified by filename, 
   * instead of using a pre-opened file.  If the file is a symlink, this function
   * will get the stats for the symlink not the file the symlink refers to.
   * @param finfo Where to store the information about the file, which is
   * never touched if the call fails.
   * @param fname The name of the file to stat.
   * @param wanted The desired apr_finfo_t fields, as a bit flag of APR_FINFO_ values 
   * @param cont the pool to use to allocate the new file. 
   * @deprecated This function is deprecated, it's equivalent to calling apr_stat with 
   * the wanted flag value APR_FINFO_LINK
    }
function apr_lstat(finfo: apr_finfo_p; fname: pchar; wanted: apr_int32_t; cont: apr_pool_p): apr_status_t; cdecl; external libapr name 'apr_lstat';

  {* @  }
  {*
   * @defgroup apr_dir Directory Manipulation Functions
   * @
    }
  {*
   * Open the specified directory.
   * @param new_dir The opened directory descriptor.
   * @param dirname The full path to the directory (use / on all systems)
   * @param cont The pool to use.
    }
function apr_dir_open(out new_dir: apr_dir_p; dirname: pchar; cont: apr_pool_p): apr_status_t; cdecl; external libapr name 'apr_dir_open';

  {*
   * close the specified directory. 
   * @param thedir the directory descriptor to close.
    }
function apr_dir_close(thedir: apr_dir_p): apr_status_t; cdecl; external libapr name 'apr_dir_close';

  {*
   * Read the next entry from the specified directory. 
   * @param finfo the file info structure and filled in by apr_dir_read
   * @param wanted The desired apr_finfo_t fields, as a bit flag of APR_FINFO_ values 
   * @param thedir the directory descriptor returned from apr_dir_open
   * @remark No ordering is guaranteed for the entries read.
    }
function apr_dir_read(finfo: apr_finfo_p; wanted: apr_int32_t; thedir: apr_dir_p): apr_status_t; cdecl; external libapr name 'apr_dir_read';

  {*
   * Rewind the directory to the first entry.
   * @param thedir the directory descriptor to rewind.
    }
function apr_dir_rewind(thedir: apr_dir_p): apr_status_t; cdecl; external libapr name 'apr_dir_rewind';

  {* @  }
  {*
   * @defgroup apr_filepath Filepath Manipulation Functions
   * @
    }
  {* Cause apr_filepath_merge to fail if addpath is above rootpath  }

  const
     APR_FILEPATH_NOTABOVEROOT = $01;     
  {* internal: Only meaningful with APR_FILEPATH_NOTABOVEROOT  }
     APR_FILEPATH_SECUREROOTTEST = $02;     
  {* Cause apr_filepath_merge to fail if addpath is above rootpath,
   * even given a rootpath /foo/bar and an addpath ../bar/bash
    }
     APR_FILEPATH_SECUREROOT = $03;     
  {* Fail apr_filepath_merge if the merged path is relative  }
     APR_FILEPATH_NOTRELATIVE = $04;     
  {* Fail apr_filepath_merge if the merged path is absolute  }
     APR_FILEPATH_NOTABSOLUTE = $08;     
  {* Return the file system's native path format (e.g. path delimiters
   * of ':' on MacOS9, '\' on Win32, etc.)  }
     APR_FILEPATH_NATIVE = $10;     
  {* Resolve the true case of existing directories and file elements
   * of addpath, (resolving any aliases on Win32) and append a proper 
   * trailing slash if a directory
    }
     APR_FILEPATH_TRUENAME = $20;     
  {*
   * Extract the rootpath from the given filepath
   * @param rootpath the root file path returned with APR_SUCCESS or APR_EINCOMPLETE
   * @param filepath the pathname to parse for its root component
   * @param flags the desired rules to apply, from
   * <PRE>
   *      APR_FILEPATH_NATIVE    Use native path seperators (e.g. '\' on Win32)
   *      APR_FILEPATH_TRUENAME  Tests that the root exists, and makes it proper
   * </PRE>
   * @param p the pool to allocate the new path string from
   * @remark on return, filepath points to the first non-root character in the
   * given filepath.  In the simplest example, given a filepath of "/foo", 
   * returns the rootpath of "/" and filepath points at "foo".  This is far 
   * more complex on other platforms, which will canonicalize the root form
   * to a consistant format, given the APR_FILEPATH_TRUENAME flag, and also
   * test for the validity of that root (e.g., that a drive d:/ or network 
   * share //machine/foovol/). 
   * The function returns APR_ERELATIVE if filepath isn't rooted (an
   * error), APR_EINCOMPLETE if the root path is ambigious (but potentially
   * legitimate, e.g. "/" on Windows is incomplete because it doesn't specify
   * the drive letter), or APR_EBADPATH if the root is simply invalid.
   * APR_SUCCESS is returned if filepath is an absolute path.
    }
function apr_filepath_root(rootpath: ppchar; filepath: ppchar; flags: apr_int32_t; p: apr_pool_p): apr_status_t; cdecl; external libapr name 'apr_filepath_root';

  {*
   * Merge additional file path onto the previously processed rootpath
   * @param newpath the merged paths returned
   * @param rootpath the root file path (NULL uses the current working path)
   * @param addpath the path to add to the root path
   * @param flags the desired APR_FILEPATH_ rules to apply when merging
   * @param p the pool to allocate the new path string from
   * @remark if the flag APR_FILEPATH_TRUENAME is given, and the addpath 
   * contains wildcard characters ('*', '?') on platforms that don't support 
   * such characters within filenames, the paths will be merged, but the 
   * result code will be APR_EPATHWILD, and all further segments will not
   * reflect the true filenames including the wildcard and following segments.
    }
function apr_filepath_merge(out newpath: pchar; rootpath, addpath: pchar; flags: apr_int32_t; p: apr_pool_p): apr_status_t; cdecl; external libapr name 'apr_filepath_merge';

  {*
   * Split a search path into separate components
   * @param pathelts the returned components of the search path
   * @param liststr the search path (e.g., <tt>getenv("PATH")</tt>)
   * @param p the pool to allocate the array and path components from
   * @remark empty path componenta do not become part of @a pathelts.
   * @remark the path separator in @a liststr is system specific;
   * e.g., ':' on Unix, ';' on Windows, etc.
    }
function apr_filepath_list_split(out pathelts: pchar; liststr: pchar; p: apr_pool_p): apr_status_t; cdecl; external libapr name 'apr_filepath_list_split';

  {*
   * Merge a list of search path components into a single search path
   * @param liststr the returned search path; may be NULL if @a pathelts is empty
   * @param pathelts the components of the search path
   * @param p the pool to allocate the search path from
   * @remark emtpy strings in the source array are ignored.
   * @remark the path separator in @a liststr is system specific;
   * e.g., ':' on Unix, ';' on Windows, etc.
    }
function apr_filepath_list_merge(out liststr: pchar; pathelts: apr_array_header_p; p: apr_pool_p): apr_status_t; cdecl; external libapr name 'apr_filepath_list_merge';

  {*
   * Return the default file path (for relative file names)
   * @param path the default path string returned
   * @param flags optional flag APR_FILEPATH_NATIVE to retrieve the
   *              default file path in os-native format.
   * @param p the pool to allocate the default path string from
    }
function apr_filepath_get(out path: pchar; flags: apr_int32_t; p: apr_pool_p): apr_status_t; cdecl; external libapr name 'apr_filepath_get';

  {*
   * Set the default file path (for relative file names)
   * @param path the default path returned
   * @param p the pool to allocate any working storage
    }
function apr_filepath_set(path: pchar; p: apr_pool_p): apr_status_t; cdecl; external libapr name 'apr_filepath_set';

const
  {* The FilePath character encoding is unknown  }
     APR_FILEPATH_ENCODING_UNKNOWN = 0;     
  {* The FilePath character encoding is locale-dependent  }
     APR_FILEPATH_ENCODING_LOCALE = 1;     
  {* The FilePath character encoding is UTF-8  }
     APR_FILEPATH_ENCODING_UTF8 = 2;     
  {*
   * Determine the encoding used internally by the FilePath functions
   * @param style points to a variable which receives the encoding style flag
   * @param p the pool to allocate any working storage
   * @remark Use @c apr_os_locale_encoding and/or @c apr_os_default_encoding
   * to get the name of the path encoding if it's not UTF-8.
    }
function apr_filepath_encoding(out style: longint; p: apr_pool_p): apr_status_t; cdecl; external libapr name 'apr_filepath_encoding';
