
(******************************************************************************
  Apache portable runtime API for FreePascal

  @defgroup apr_strings String routines
  @ingroup APR 
  
  Note: I'm expect what it is very buggy... be careful ;)

  Zolotov Alex, 2007-2008
  zolotov-alex@shamangrad.net
  http://shamangrad.net/

 *****************************************************************************)

  {*
   * Do a natural order comparison of two strings.
   * @param a The first string to compare
   * @param b The second string to compare
   * @return Either <0, 0, or >0.  If the first string is less than the second
   *          this returns <0, if they are equivalent it returns 0, and if the
   *          first string is greater than second string it retuns >0.
    }
function apr_strnatcmp(a, b: pchar): longint; cdecl; external libapr name 'apr_strnatcmp';

  {*
   * Do a natural order comparison of two strings ignoring the case of the 
   * strings.
   * @param a The first string to compare
   * @param b The second string to compare
   * @return Either <0, 0, or >0.  If the first string is less than the second
   *         this returns <0, if they are equivalent it returns 0, and if the
   *         first string is greater than second string it retuns >0.
    }
function apr_strnatcasecmp(a, b: pchar): longint; cdecl; external libapr name 'apr_strnatcasecmp';

  {*
   * duplicate a string into memory allocated out of a pool
   * @param p The pool to allocate out of
   * @param s The string to duplicate
   * @return The new string
    }
function apr_pstrdup(p: apr_pool_p; s: pchar): pchar; cdecl; external libapr name 'apr_pstrdup';

  {*
   * Create a null-terminated string by making a copy of a sequence
   * of characters and appending a null byte
   * @param p The pool to allocate out of
   * @param s The block of characters to duplicate
   * @param n The number of characters to duplicate
   * @return The new string
   * @remark This is a faster alternative to apr_pstrndup, for use
   *         when you know that the string being duplicated really
   *         has 'n' or more characters.  If the string might contain
   *         fewer characters, use apr_pstrndup.
    }
function apr_pstrmemdup(p: apr_pool_p; s: pchar; n: apr_size_t): pchar; cdecl; external libapr name 'apr_pstrmemdup';

  {*
   * duplicate the first n characters of a string into memory allocated 
   * out of a pool; the new string will be null-terminated
   * @param p The pool to allocate out of
   * @param s The string to duplicate
   * @param n The number of characters to duplicate
   * @return The new string
    }
function apr_pstrndup(p: apr_pool_p; s: pchar; n: apr_size_t): pchar; cdecl; external libapr name 'apr_pstrndup';

  {*
   * Duplicate a block of memory.
   *
   * @param p The pool to allocate from
   * @param m The memory to duplicate
   * @param n The number of bytes to duplicate
   * @return The new block of memory
    }
function apr_pmemdup(p: apr_pool_p; m: pointer; n: apr_size_t): pointer; cdecl; external libapr name 'apr_pmemdup';

  {*
   * Concatenate multiple strings, allocating memory out a pool
   * @param p The pool to allocate out of
   * @param ... The strings to concatenate.  The final string must be NULL
   * @return The new string
    }
//APR_DECLARE_NONSTD(char *) apr_pstrcat(apr_pool_t *p, ...);

  {*
   * Concatenate multiple strings specified in a writev-style vector
   * @param p The pool from which to allocate
   * @param vec The strings to concatenate
   * @param nvec The number of strings to concatenate
   * @param nbytes (output) strlen of new string (pass in NULL to omit)
   * @return The new string
    }
function apr_pstrcatv(p: apr_pool_p; vec: pointer; nvec: apr_size_t; nbytes: apr_size_t): pchar; cdecl; external libapr name 'apr_pstrcatv';

  {*
   * printf-style style printing routine.  The data is output to a string 
   * allocated from a pool
   * @param p The pool to allocate out of
   * @param fmt The format of the string
   * @param ap The arguments to use while printing the data
   * @return The new string
    }
//function apr_pvsprintf(p: apr_pool_p; fmt: pchar; ap: va_list): pchar; cdecl; external libapr name '';

  {*
   * printf-style style printing routine.  The data is output to a string 
   * allocated from a pool
   * @param p The pool to allocate out of
   * @param fmt The format of the string
   * @param ... The arguments to use while printing the data
   * @return The new string
    }
//APR_DECLARE_NONSTD(char *) apr_psprintf(apr_pool_t *p, const char *fmt, ...)
//        __attribute__((format(printf,2,3)));

  {*
   * copy n characters from src to dst
   * @param dst The destination string
   * @param src The source string
   * @param dst_size The space available in dst; dst always receives
   *                 null-termination, so if src is longer than
   *                 dst_size, the actual number of characters copied is
   *                 dst_size - 1.
   * @remark
   * <PRE>
   * We re-implement this function to implement these specific changes:
   *       1) strncpy() doesn't always null terminate and we want it to.
   *       2) strncpy() null fills, which is bogus, esp. when copy 8byte strings
   *          into 8k blocks.
   *       3) Instead of returning the pointer to the beginning of the
   *          destination string, we return a pointer to the terminating null
   *          to allow us to check for truncation.
   * </PRE>
    }
function apr_cpystrn(dst, src: pchar; dst_size: pchar): pchar; cdecl; external libapr name 'apr_cpystrn';

  {*
   * Strip spaces from a string
   * @param dest The destination string.  It is okay to modify the string
   *             in place.  Namely dest == src
   * @param src The string to rid the spaces from.
    }
function apr_collapse_spaces(dest, src: pchar): pchar; cdecl; external libapr name 'apr_collapse_spaces';

  {*
   * Convert the arguments to a program from one string to an array of 
   * strings terminated by a NULL pointer
   * @param arg_str The arguments to convert
   * @param argv_out Output location.  This is a pointer to an array of strings.
   * @param token_context Pool to use.
    }
function apr_tokenize_to_argv(arg_str: pchar; out argv: ppchar; token_context: apr_pool_p): apr_status_t; cdecl; external libapr name 'apr_tokenize_to_argv';

  {*
   * Split a string into separate null-terminated tokens.  The tokens are 
   * delimited in the string by one or more characters from the sep
   * argument.
   * @param str The string to separate; this should be specified on the
   *            first call to apr_strtok() for a given string, and NULL
   *            on subsequent calls.
   * @param sep The set of delimiters
   * @param last Internal state saved by apr_strtok() between calls.
   * @return The next token from the string
    }
function apr_strtok(str: pchar; sep: pchar; var last: pchar): pchar; cdecl; external libapr name 'apr_strtok';

  {*
   * @defgroup APR_Strings_Snprintf snprintf implementations
   * @warning
   * These are snprintf implementations based on apr_vformatter().
   *
   * Note that various standards and implementations disagree on the return
   * value of snprintf, and side-effects due to %n in the formatting string.
   * apr_snprintf (and apr_vsnprintf) behaves as follows:
   *
   * Process the format string until the entire string is exhausted, or
   * the buffer fills.  If the buffer fills then stop processing immediately
   * (so no further %n arguments are processed), and return the buffer
   * length.  In all cases the buffer is NUL terminated. It will return the
   * number of characters inserted into the buffer, not including the
   * terminating NUL. As a special case, if len is 0, apr_snprintf will
   * return the number of characters that would have been inserted if
   * the buffer had been infinite (in this case, *buffer can be NULL)
   *
   * In no event does apr_snprintf return a negative number.
   * @
    }
  {*
   * snprintf routine based on apr_vformatter.  This means it understands the
   * same extensions.
   * @param buf The buffer to write to
   * @param len The size of the buffer
   * @param format The format string
   * @param ... The arguments to use to fill out the format string.
    }
//APR_DECLARE_NONSTD(int) apr_snprintf(char *buf, apr_size_t len,
//                                     const char *format, ...)
//        __attribute__((format(printf,3,4)));

  {*
   * vsnprintf routine based on apr_vformatter.  This means it understands the
   * same extensions.
   * @param buf The buffer to write to
   * @param len The size of the buffer
   * @param format The format string
   * @param ap The arguments to use to fill out the format string.
    }
//function apr_vsnprintf(buf: pchar; len: apr_size_t; format: pchar; ap: va_list): longint; cdecl; external libapr name '';

  {* @  }
  {*
   * create a string representation of an int, allocated from a pool
   * @param p The pool from which to allocate
   * @param n The number to format
   * @return The string representation of the number
    }
function apr_itoa(p: apr_pool_p; n: integer): pchar; cdecl; external libapr name 'apr_itoa';

  {*
   * create a string representation of a long, allocated from a pool
   * @param p The pool from which to allocate
   * @param n The number to format
   * @return The string representation of the number
    }
function apr_ltoa(p: apr_pool_p; n: longint): pchar; cdecl; external libapr name 'apr_ltoa';

  {*
   * create a string representation of an apr_off_t, allocated from a pool
   * @param p The pool from which to allocate
   * @param n The number to format
   * @return The string representation of the number
    }
function apr_off_t_toa(p: apr_pool_p; n: apr_off_t): pchar; cdecl; external libapr name 'apr_off_t_toa';

  {*
   * parse a numeric string into a 64-bit numeric value
   * @param buf The string to parse. It may contain optional whitespace,
   *   followed by an optional '+' (positive, default) or '-' (negative)
   *   character, followed by an optional '0x' prefix if base is 0 or 16,
   *   followed by numeric digits appropriate for base.
   * @param end A pointer to the end of the valid character in buf. If
   *   not nil, it is set to the first invalid character in buf.
   * @param base A numeric base in the range between 2 and 36 inclusive,
   *   or 0.  If base is zero, buf will be treated as base ten unless its
   *   digits are prefixed with '0x', in which case it will be treated as
   *   base 16.
   * @return The numeric value of the string.
    }
function apr_strtoi64(buf: pchar; _end: ppchar; base: integer): apr_int64_t; cdecl; external libapr name 'apr_strtoi64';

  {*
   * parse a base-10 numeric string into a 64-bit numeric value.
   * Equivalent to apr_strtoi64(buf, (char**)NULL, 10).
   * @param buf The string to parse
   * @return The numeric value of the string
    }
function apr_atoi64(buf: pchar): apr_int64_t; cdecl; external libapr name 'apr_atoi64';
