program mftest;

{$ifdef FPC}
  {$mode delphi}
  {$h+}
  {$assertions on}
{$endif}

uses SysUtils, Classes, mxmetafile;

procedure test;
var 
  mf: TMXMetafile;
begin
  mf := TMXMetafile.Create;
  try
    //mf.LoadFromFile('test.mf');
    mf.LookupSection('package').Comment := 'Описание пакета';
    mf.LookupSection('compile').Comment := 'Модули для компиляции';
    mf.AddOption('package', 'title', 'Тестовый пакет');
    mf.AddOption('package', 'name', 'metafile');
    mf.AddOption('package', 'version', '1.0');
    mf.AddOption('package', 'author', 'Золотов Алексей');
    mf.AddOption('compile', 'unit', 'mxmetafile.pas', 'Модуль для работы с метафайлами');
    mf.AddOption('compile', 'program', 'mftest.pas', 'Тестовая программа'#10'пример работы с метафайлами');
    mf.SaveToFile('test.mf');
  finally
    mf.Free;
  end;
end;

begin
  try
    test;
    writeln;
    writeln('ok');
  except
    on E: Exception do
    begin
      writeln;
      writeln(E.ClassName, ': ', E.Message);
    end;
  end;
end.
