unit mxutils;

(******************************************************************************
  mxutils.pas
    Some base types, consts and functions of mxlib
  
  Copyright notice:

 (c) 2008 Zolotov Alex

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.

  Zolotov Alex, 2008
    zolotov-alex@shamangrad.net
    http://shamangrad.net/

 ******************************************************************************)

{$ifdef FPC}
  {$mode delphi}
  {$h+}
  {$assertions on}
{$endif}

interface

type
  TStringArray = array of string;

function Explode(Ch: Char; const Text: string): TStringArray;
function Implode(Ch: Char; const StrArr: TStringArray): string;

implementation

function Explode(Ch: Char; const Text: string): TStringArray;
var
  i, k, Len: Integer;
  Count: Integer;
begin
  if Text = '' then
  begin
    Result := nil;
    Exit;
  end; // if
  Count := 0;
  Len := Length(Text);
  for i := 1 to Len do
  begin
    if Text[i] = Ch then Inc(Count);
  end; // for i
  SetLength(Result, Count + 1);
  Count := 0;
  k := 1;
  for i := 1 to Len do
  begin
    if Text[i] = Ch then
    begin
      Result[Count] := Copy(Text, k, i - k);
      Inc(Count);
      k := i + 1;
    end; // if
  end;
  Result[Count] := Copy(Text, k, Len - k + 1);
end;

function Implode(Ch: Char; const StrArr: TStringArray): string;
var
  i, k, Count, Len: Integer;
  p: PChar;
begin
  if StrArr = nil then
  begin
    Result := '';
    Exit;
  end; // if
  Count := Length(StrArr);
  if Count = 0 then
  begin
    Result := '';
    Exit;
  end; // if
  Len := Count-1;
  for i := 0 to Count-1 do Inc(Len, Length(StrArr[i]));
  SetLength(Result, Len);
  p := PChar(Result);
  for i := 0 to Count-2 do
  begin
    k := Length(StrArr[i]);
    System.Move(Pointer(StrArr[i])^, p^, k);
    p[k] := ch;
    Inc(p, k+1);
  end; // if
  System.Move(Pointer(StrArr[Count-1])^, p^, Length(StrArr[Count-1]));
end;

end.
