unit mxsqlite3;

(******************************************************************************
  Copyright notice:

 (C) 2006-2008 Zolotov Alex

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.

  Zolotov Alex
  zolotov-alex@shamangrad.net
  http://shamangrad.net/

 ******************************************************************************

       SQLite3 (sqlite3.dll  libsqlite3.so)
   : 1.0

   SQLite3.pas

   (c) Zolotov Alex, 2006-2008
   e-mail:  zolotov-alex@shamangrad.net
   url:     http://shamangrad.net/

 *****************************************************************************)

{$IFDEF FPC}
  {$MODE OBJFPC}
  {$H+}
{$ENDIF}

interface

type
  PPChar = ^PChar;
  PPPChar = ^PPChar;

  sqlite3_p = ^ sqlite3_t;
  sqlite3_t = record
  end;

  sqlite3_context_p = ^sqlite3_context_t;
  sqlite3_context_t = record
  end;

  sqlite3_statement_p = ^sqlite3_statement_t;
  sqlite3_statement_t = record
  end;

  sqlite3_value_p = ^sqlite3_value_t;
  sqlite3_value_t = record
  end;

  sqlite3_blob_p = ^sqlite3_blob_t;
  sqlite3_blob_t = record
  end;

  sqlite3_value_list_p = ^sqlite3_value_list_t;
  sqlite3_value_list_t = array [0..0] of sqlite3_value_p;

  PCharList = ^PCharList_t;
  PCharList_t = array [0..0] of PChar;

  TDestructor = procedure (p: Pointer); cdecl;
  TBusyHandler = function (p: Pointer; x: Integer): Integer; cdecl;
  TCollationProc = procedure (Param: Pointer; sqlite3: sqlite3_p; eTextRep: Integer; Name: PChar); cdecl;
  TCollationProc16 = procedure (Param: Pointer; sqlite3: sqlite3_p; eTextRep: Integer; Name: PWideChar); cdecl;
  TCommitHook = function (Param: Pointer): Integer; cdecl;
  TRollbackHook = procedure (Param: Pointer); cdecl;
  TUpdateHook = procedure (Param: Pointer; StmtKind: Integer; DBName, TableName: PChar; ROWID: Int64); cdecl;
  TProgressHandler = function (Param: Pointer): Integer; cdecl;
  TCompareProc = function (Param: Pointer; Len1: Integer; Data1: Pointer; Len2: Integer; Data2: Pointer): Integer; cdecl;
  TFunctionProc = procedure (context: sqlite3_context_p; nArg: Integer; Args: sqlite3_value_list_p); cdecl;
  TStepProc = procedure (context: sqlite3_context_p; nArg: Integer; Args: sqlite3_value_list_p); cdecl;
  TFinalProc = procedure (context: sqlite3_context_p); cdecl;
  TExecCallback = function(Param: Pointer; ColCount: Integer; Cols, ColNames: PCharList): Integer; cdecl;
  TAuthProc = function (Param: Pointer; StmtKind: Integer; Arg1, Arg2: PChar; DBName: PChar; Trigger: PChar) : Integer; cdecl;
  TTraceProc = procedure (Param: Pointer; p{?}: PChar); cdecl;

const
  SQLITE_OK         =  0;   (* Successful result *)
  SQLITE_ERROR      =  1;   (* SQL error or missing database *)
  SQLITE_INTERNAL   =  2;   (* An internal logic error in SQLite *)
  SQLITE_PERM       =  3;   (* Access permission denied *)
  SQLITE_ABORT      =  4;   (* Callback routine requested an abort *)
  SQLITE_BUSY       =  5;   (* The database file is locked *)
  SQLITE_LOCKED     =  6;   (* A table in the database is locked *)
  SQLITE_NOMEM      =  7;   (* A malloc() failed *)
  SQLITE_READONLY   =  8;   (* Attempt to write a readonly database *)
  SQLITE_INTERRUPT  =  9;   (* Operation terminated by sqlite_interrupt() *)
  SQLITE_IOERR      = 10;   (* Some kind of disk I/O error occurred *)
  SQLITE_CORRUPT    = 11;   (* The database disk image is malformed *)
  SQLITE_NOTFOUND   = 12;   (* (Internal Only) Table or record not found *)
  SQLITE_FULL       = 13;   (* Insertion failed because database is full *)
  SQLITE_CANTOPEN   = 14;   (* Unable to open the database file *)
  SQLITE_PROTOCOL   = 15;   (* Database lock protocol error *)
  SQLITE_EMPTY      = 16;   (* (Internal Only) Database table is empty *)
  SQLITE_SCHEMA     = 17;   (* The database schema changed *)
  SQLITE_TOOBIG     = 18;   (* Too much data for one row of a table *)
  SQLITE_CONSTRAINT = 19;   (* Abort due to constraint violation *)
  SQLITE_MISMATCH   = 20;   (* Data type mismatch *)
  SQLITE_MISUSE     = 21;   (* Library used incorrectly *)
  SQLITE_NOLFS      = 22;   (* Uses OS features not supported on host *)
  SQLITE_AUTH       = 23;   (* Authorization denied *)
  SQLITE_ROW        = 100;  (* sqlite_step() has another row ready *)
  SQLITE_DONE       = 101;  (* sqlite_step() has finished executing *)

  SQLITE_STATIC     = Pointer(0);
  SQLITE_TRANSIENT  = Pointer(-1);

  SQLITE_INTEGER  = 1;
  SQLITE_FLOAT    = 2;
  SQLITE_TEXT     = 3;
  SQLITE_BLOB     = 4;
  SQLITE_NULL     = 5;

  SQLITE_UTF8     = 1;
  SQLITE_UTF16BE  = 2;
  SQLITE_UTF16LE  = 3;
  SQLITE_UTF16    = 4;
  SQLITE_ANY      = 5;

  SQLITE_CREATE_INDEX         =  1;   (* Index Name      Table Name      *)
  SQLITE_CREATE_TABLE         =  2;   (* Table Name      NULL            *)
  SQLITE_CREATE_TEMP_INDEX    =  3;   (* Index Name      Table Name      *)
  SQLITE_CREATE_TEMP_TABLE    =  4;   (* Table Name      NULL            *)
  SQLITE_CREATE_TEMP_TRIGGER  =  5;   (* Trigger Name    Table Name      *)
  SQLITE_CREATE_TEMP_VIEW     =  6;   (* View Name       NULL            *)
  SQLITE_CREATE_TRIGGER       =  7;   (* Trigger Name    Table Name      *)
  SQLITE_CREATE_VIEW          =  8;   (* View Name       NULL            *)
  SQLITE_DELETE               =  9;   (* Table Name      NULL            *)
  SQLITE_DROP_INDEX           = 10;   (* Index Name      Table Name      *)
  SQLITE_DROP_TABLE           = 11;   (* Table Name      NULL            *)
  SQLITE_DROP_TEMP_INDEX      = 12;   (* Index Name      Table Name      *)
  SQLITE_DROP_TEMP_TABLE      = 13;   (* Table Name      NULL            *)
  SQLITE_DROP_TEMP_TRIGGER    = 14;   (* Trigger Name    Table Name      *)
  SQLITE_DROP_TEMP_VIEW       = 15;   (* View Name       NULL            *)
  SQLITE_DROP_TRIGGER         = 16;   (* Trigger Name    Table Name      *)
  SQLITE_DROP_VIEW            = 17;   (* View Name       NULL            *)
  SQLITE_INSERT               = 18;   (* Table Name      NULL            *)
  SQLITE_PRAGMA               = 19;   (* Pragma Name     1st arg or NULL *)
  SQLITE_READ                 = 20;   (* Table Name      Column Name     *)
  SQLITE_SELECT               = 21;   (* NULL            NULL            *)
  SQLITE_TRANSACTION          = 22;   (* NULL            NULL            *)
  SQLITE_UPDATE               = 23;   (* Table Name      Column Name     *)
  SQLITE_ATTACH               = 24;   (* Filename        NULL            *)
  SQLITE_DETACH               = 25;   (* Database Name   NULL            *)
  SQLITE_ALTER_TABLE          = 26;   (* Database Name   Table Name      *)
  SQLITE_REINDEX              = 27;   (* Index Name      NULL            *)
  SQLITE_ANALYZE              = 28;   (* Table Name      NULL            *)

  SQLITE_DENY   = 1;   (* Abort the SQL statement with an error *)
  SQLITE_IGNORE = 2;   (* Don't allow access, but don't generate an error *)

const SQLite3_lib = 'sqlite3';

function sqlite3_aggregate_context(context: sqlite3_context_p; nBytes: Integer): Pointer; cdecl; external SQLite3_lib;
function sqlite3_aggregate_count(context: sqlite3_context_p): Integer; cdecl; external SQLite3_lib;
function sqlite3_bind_blob(stmt: sqlite3_statement_p; Indx: Integer; Blob: Pointer; nBytes: Integer; Destruct: TDestructor): Integer; cdecl; external SQLite3_lib;
function sqlite3_bind_double(stmt: sqlite3_statement_p; Indx: Integer; Value: Double): Integer; cdecl; external SQLite3_lib;
function sqlite3_bind_int(stmt: sqlite3_statement_p; Indx: Integer; Value: Integer): Integer; cdecl; external SQLite3_lib;
function sqlite3_bind_int64(stmt: sqlite3_statement_p; Indx: Integer; Value: Int64): Integer; cdecl; external SQLite3_lib;
function sqlite3_bind_null(stmt: sqlite3_statement_p; Indx: Integer): Integer; cdecl; external SQLite3_lib;
function sqlite3_bind_text(stmt: sqlite3_statement_p; Indx: Integer; Text: PChar; nBytes: Integer; Destruct: TDestructor): Integer; cdecl; external SQLite3_lib;
function sqlite3_bind_text16(stmt: sqlite3_statement_p; Indx: Integer; Text: PWideChar; nBytes: Integer; Destruct: TDestructor): Integer; cdecl; external SQLite3_lib;
function sqlite3_bind_parameter_count(stmt: sqlite3_statement_p): Integer; cdecl; external SQLite3_lib;
function sqlite3_bind_parameter_index(stmt: sqlite3_statement_p; zName: PChar): Integer; cdecl; external SQLite3_lib;
function sqlite3_bind_parameter_name(stmt: sqlite3_statement_p; Indx: Integer): PChar; cdecl; external SQLite3_lib;
function sqlite3_bind_zeroblob(stmt: sqlite3_statement_p; Indx: Integer; Size: Integer): Integer; cdecl; external SQLite3_lib;
function sqlite3_blob_bytes(blob: sqlite3_blob_p): Integer; cdecl; external SQLite3_lib;
function sqlite3_blob_close(blob: sqlite3_blob_p): Integer; cdecl; external SQLite3_lib;
function sqlite3_blob_open(sqlite3: sqlite3_p; zDb: PChar; zTable: PChar; zColumn: PChar; iRow: Int64; Flags: Integer; var ppBlob: sqlite3_blob_p): Integer; cdecl; external SQLite3_lib;
function sqlite3_blob_read(blob: sqlite3_blob_p; z: PChar; n: Integer; iOffset: Integer): Integer; cdecl; external SQLite3_lib;
function sqlite3_blob_write(blob: sqlite3_blob_p; z: PChar; n: Integer; iOffset: Integer): Integer; cdecl; external SQLite3_lib;

function sqlite3_busy_handler(sqlite3: sqlite3_p; Handler: TBusyHandler; Param: Pointer): Integer; cdecl; external SQLite3_lib;
function sqlite3_busy_timeout(sqlite3: sqlite3_p; ms: Integer): Integer; cdecl; external SQLite3_lib;
function sqlite3_changes(sqlite3: sqlite3_p): Integer; cdecl; external SQLite3_lib;
function sqlite3_clear_bindings(stmt: sqlite3_statement_p): Integer; cdecl; external SQLite3_lib;
function sqlite3_close(sqlite3: sqlite3_p): Integer; cdecl; external SQLite3_lib;
function sqlite3_collation_needed(sqlite3: sqlite3_p; Param: Pointer; CollationProc: TCollationProc): Integer; cdecl; external SQLite3_lib;
function sqlite3_collation_needed16(sqlite3: sqlite3_p; Param: Pointer; CollationProc: TCollationProc16): Integer; cdecl; external SQLite3_lib;
function sqlite3_column_blob(stmt: sqlite3_statement_p; iCol: Integer): Pointer; cdecl; external SQLite3_lib;
function sqlite3_column_bytes(stmt: sqlite3_statement_p; iCol: Integer): Integer; cdecl; external SQLite3_lib;
function sqlite3_column_bytes16(stmt: sqlite3_statement_p; iCol: Integer): Integer; cdecl; external SQLite3_lib;
function sqlite3_column_double(stmt: sqlite3_statement_p; iCol: Integer): double; cdecl; external SQLite3_lib;
function sqlite3_column_int(stmt: sqlite3_statement_p; iCol: Integer): Integer; cdecl; external SQLite3_lib;
function sqlite3_column_int64(stmt: sqlite3_statement_p; iCol: Integer): Int64; cdecl; external SQLite3_lib;
function sqlite3_column_text(stmt: sqlite3_statement_p; iCol: Integer): PChar; cdecl; external SQLite3_lib;
function sqlite3_column_text16(stmt: sqlite3_statement_p; iCol: Integer): PWideChar; cdecl; external SQLite3_lib;
function sqlite3_column_type(stmt: sqlite3_statement_p; iCol: Integer): Integer; cdecl; external SQLite3_lib;
function sqlite3_column_count(stmt: sqlite3_statement_p): Integer; cdecl; external SQLite3_lib;
function sqlite3_column_database_name(stmt: sqlite3_statement_p; Indx: Integer): PChar; cdecl; external SQLite3_lib;
function sqlite3_column_database_name16(stmt: sqlite3_statement_p; Indx: Integer): PWideChar; cdecl; external SQLite3_lib;
function sqlite3_column_decltype(stmt: sqlite3_statement_p; Indx: Integer): PChar; cdecl; external SQLite3_lib;
function sqlite3_column_decltype16(stmt: sqlite3_statement_p; Indx: Integer): PWideChar; cdecl; external SQLite3_lib;
function sqlite3_column_name(stmt: sqlite3_statement_p; Indx: Integer): PChar; cdecl; external SQLite3_lib;
function sqlite3_column_name16(stmt: sqlite3_statement_p; Indx: Integer): PWideChar; cdecl; external SQLite3_lib;
function sqlite3_column_origin_name(stmt: sqlite3_statement_p; Indx: Integer): PChar; cdecl; external SQLite3_lib;
function sqlite3_column_origin_name16(stmt: sqlite3_statement_p; Indx: Integer): PWideChar; cdecl; external SQLite3_lib;
function sqlite3_column_table_name(stmt: sqlite3_statement_p; Indx: Integer): PChar; cdecl; external SQLite3_lib;
function sqlite3_column_table_name16(stmt: sqlite3_statement_p; Indx: Integer): PWideChar; cdecl; external SQLite3_lib;
function sqlite3_commit_hook(sqlite3: sqlite3_p; hook: TCommitHook; Param: Pointer): Pointer; cdecl; external SQLite3_lib;
function sqlite3_complete(sql: PChar): Integer; cdecl; external SQLite3_lib;
function sqlite3_complete16(sql: PWideChar): Integer; cdecl; external SQLite3_lib;

function sqlite3_create_collation(
        sqlite3: sqlite3_p;
        Name: PChar;
        pref16: Integer;
        Param: Pointer;
        CompareProc: TCompareProc
        ): Integer; cdecl; external SQLite3_lib;

function sqlite3_create_collation16(
        sqlite3: sqlite3_p;
        Name: PWideChar;
        pref16: Integer;
        Param: Pointer;
        CompareProc: TCompareProc
        ): Integer; cdecl; external SQLite3_lib;

function sqlite3_create_function(
        sqlite3: sqlite3_p;
        Name: PChar;
        nArg: Integer;
        eTextRep: Integer;
        pUserData: Pointer;
        Func: TFunctionProc;
        Step: TStepProc;
        Final: TFinalProc
        ): Integer; cdecl; external SQLite3_lib;

function sqlite3_create_function16(
        sqlite3: sqlite3_p;
        Name: PWideChar;
        nArg: Integer;
        eTextRep: Integer;
        pUserData: Pointer;
        Func: TFunctionProc;
        Step: TStepProc;
        Final: TFinalProc
        ): Integer; cdecl; external SQLite3_lib;

function sqlite3_data_count(stmt: sqlite3_statement_p): Integer; cdecl; external SQLite3_lib;
function sqlite3_db_handle(stmt: sqlite3_statement_p): sqlite3_p; cdecl; external SQLite3_lib;
function sqlite3_enable_shared_cache(Value: Integer): Integer; cdecl; external SQLite3_lib;
function sqlite3_errcode(sqlite3: sqlite3_p): Integer; cdecl; external SQLite3_lib;
function sqlite3_errmsg(sqlite3: sqlite3_p): PChar; cdecl; external SQLite3_lib;
function sqlite3_errmsg16(sqlite3: sqlite3_p): PWideChar; cdecl; external SQLite3_lib;

function sqlite3_exec(
        sqlite3: sqlite3_p;
        sql: PChar;
        callback: TExecCallback;
        Param: Pointer;
        ErrMsg: PPChar
        ): Integer; cdecl; external SQLite3_lib;

function sqlite3_expired(stmt: sqlite3_statement_p): Integer; cdecl; external SQLite3_lib;
function sqlite3_finalize(sqlite3_stmt: sqlite3_statement_p): Integer; cdecl; external SQLite3_lib;
procedure sqlite3_free(p: Pointer); cdecl; external SQLite3_lib;

function sqlite3_get_table(
  sqlite: sqlite3_p;
  sql: PChar; resultp:
  PPPChar;
  nrow: PInteger;
  ncolumnt: PInteger;
  ErrMsg: PPChar
  ): Integer; cdecl; external SQLite3_lib;

procedure sqlite3_free_table(Result: PPChar); cdecl; external SQLite3_lib;
function sqlite3_get_autocommit(sqlite3: sqlite3_p): Integer; cdecl; external SQLite3_lib;
function sqlite3_global_recover: Integer; cdecl; external SQLite3_lib;
procedure sqlite3_interrupt(sqlite3: sqlite3_p); cdecl; external SQLite3_lib;
function sqlite3_last_insert_rowid(sqlite3: sqlite3_p): Int64; cdecl; external SQLite3_lib;
function SQLite3_libversion: PChar; cdecl; external SQLite3_lib;
function sqlite3_mprintf(fmt: PChar{???}): PChar; cdecl; external SQLite3_lib;
function sqlite3_vmprintf(fmt: PChar; list: Pointer): PChar; cdecl; external SQLite3_lib;
function sqlite3_open(fname: PChar; var sqlite3: sqlite3_p): Integer; cdecl; external SQLite3_lib;
function sqlite3_open16(fname: PWideChar; var sqlite3: sqlite3_p): Integer; cdecl; external SQLite3_lib;

function sqlite3_prepare(
        sqlite3: sqlite3_p;
        sql: PChar;
        Len: Integer;
        var sqlite3_stmt: sqlite3_statement_p;
        var pzTail: PChar
        ): Integer; cdecl; external SQLite3_lib;

function sqlite3_prepare16(
        sqlite3: sqlite3_p;
        sql: PWideChar;
        Len: Integer;
        var sqlite3_stmt: sqlite3_statement_p;
        var pzTail: PWideChar
        ): Integer; cdecl; external SQLite3_lib;

procedure sqlite3_progress_handler(sqlite3: sqlite3_p; N: Integer; Handler: TProgressHandler; Param: Pointer); cdecl; external SQLite3_lib;
function sqlite3_release_memory(N: Integer): Integer; cdecl; external SQLite3_lib;
function sqlite3_reset(stmt: sqlite3_statement_p): Integer; cdecl; external SQLite3_lib;
procedure sqlite3_result_blob(context: sqlite3_context_p; Blob: Pointer; nBytes: Integer; Destruct: TDestructor); cdecl; external SQLite3_lib;
procedure sqlite3_result_double(context: sqlite3_context_p; Value: double); cdecl; external SQLite3_lib;
procedure sqlite3_result_error(context: sqlite3_context_p; p: PChar; l: Integer); cdecl; external SQLite3_lib;
procedure sqlite3_result_error16(context: sqlite3_context_p; p: PWideChar; l: Integer); cdecl; external SQLite3_lib;
procedure sqlite3_result_int(context: sqlite3_context_p; Value: Integer); cdecl; external SQLite3_lib;
procedure sqlite3_result_int64(context: sqlite3_context_p; Value: Int64); cdecl; external SQLite3_lib;
procedure sqlite3_result_null(context: sqlite3_context_p); cdecl; external SQLite3_lib;
procedure sqlite3_result_text(context: sqlite3_context_p; Text: PChar; nBytes: Integer; Destruct: TDestructor); cdecl; external SQLite3_lib;
procedure sqlite3_result_text16(context: sqlite3_context_p; Text: PWideChar; nBytes: Integer; Destruct: TDestructor); cdecl; external SQLite3_lib;
procedure sqlite3_result_text16be(context: sqlite3_context_p; Text: PWideChar; nBytes: Integer; Destruct: TDestructor); cdecl; external SQLite3_lib;
procedure sqlite3_result_text16le(context: sqlite3_context_p; Text: PWideChar; nBytes: Integer; Destruct: TDestructor); cdecl; external SQLite3_lib;
procedure sqlite3_result_value(context: sqlite3_context_p; Value: sqlite3_value_p); cdecl; external SQLite3_lib;
function sqlite3_rollback_hook(sqlite3: sqlite3_p; hook: TRollbackHook; Param: Pointer): Pointer; cdecl; external SQLite3_lib;
function sqlite3_set_authorizer(sqlite3: sqlite3_p; AuthProc: TAuthProc; Param: Pointer): Integer; cdecl; external SQLite3_lib;
function sqlite3_sleep(N: Integer): Integer; cdecl; external SQLite3_lib;
procedure sqlite3_soft_heap_limit(N: Integer); cdecl; external SQLite3_lib;
function sqlite3_step(sqlite3_stmt: sqlite3_statement_p): Integer; cdecl; external SQLite3_lib;

function sqlite3_table_column_metadata(
        sqlite3: sqlite3_p;
        dbName: PChar;
        TableName: PChar;
        ColumnName: PChar;
        DataType: PPChar;
        CollSeq: PPChar;
        NotNull: PInteger;
        PrimaryKey: PInteger;
        Autoinc: PInteger
        ): Integer; cdecl; external SQLite3_lib;

procedure sqlite3_thread_cleanup; cdecl; external SQLite3_lib;
function sqlite3_total_changes(sqlite: sqlite3_p): Integer; cdecl; external SQLite3_lib;
function sqlite3_trace(sqlite: sqlite3_p; TraceProc: TTraceProc; Param: Pointer): Pointer; cdecl; external SQLite3_lib;
function sqlite3_transfer_bindings(stmt1, stmt2: sqlite3_statement_p): Integer; cdecl; external SQLite3_lib;
function sqlite3_update_hook(sqlite3: sqlite3_p; hook: TUpdateHook; Param: Pointer): Pointer; cdecl; external SQLite3_lib;
function sqlite3_user_data(context: sqlite3_context_p): Pointer; cdecl; external SQLite3_lib;
function sqlite3_value_blob(sVal: sqlite3_value_p): Pointer; cdecl; external SQLite3_lib;
function sqlite3_value_bytes(sVal: sqlite3_value_p): Integer; cdecl; external SQLite3_lib;
function sqlite3_value_bytes16(sVal: sqlite3_value_p): Integer; cdecl; external SQLite3_lib;
function sqlite3_value_double(sVal: sqlite3_value_p): double; cdecl; external SQLite3_lib;
function sqlite3_value_int(sVal: sqlite3_value_p): Integer; cdecl; external SQLite3_lib;
function sqlite3_value_int64(sVal: sqlite3_value_p): Int64; cdecl; external SQLite3_lib;
function sqlite3_value_text(sVal: sqlite3_value_p): PChar; cdecl; external SQLite3_lib;
function sqlite3_value_text16(sVal: sqlite3_value_p): PWideChar; cdecl; external SQLite3_lib;
function sqlite3_value_text16be(sVal: sqlite3_value_p): PWideChar; cdecl; external SQLite3_lib;
function sqlite3_value_text16le(sVal: sqlite3_value_p): PWideChar; cdecl; external SQLite3_lib;
function sqlite3_value_type(sVal: sqlite3_value_p): Integer; cdecl; external SQLite3_lib;

implementation

end.
