
(******************************************************************************
    
  Subversion Client API for FreePascal

  Some consts, types and strutures of SVN API to use libraries:
     libsvn_client
     libsvn_subr
     libsvn_auth
     libsvn_wc
     
    Note: I'm expect what it is very buggy... be careful ;)

  There are all that need to use libsvn_client and something more.
  May be later somebody add all other const, types and structures
  or clean it up of garbage

  Zolotov Alex, 2007-2008
  zolotov-alex@shamangrad.net
  http://shamangrad.net/

 *****************************************************************************)

const
  SVN_NO_ERROR = 0;
  
  SVN_ALLOCATOR_RECOMMENDED_MAX_FREE = 4096*1024;

  SVN_AUTH_CRED_SIMPLE = 'svn.simple';
  SVN_AUTH_CRED_USERNAME = 'svn.username';
  SVN_AUTH_CRED_SSL_CLIENT_CERT = 'svn.ssl.client-cert';
  SVN_AUTH_CRED_SSL_CLIENT_CERT_PW = 'svn.ssl.client-passphrase';
  SVN_AUTH_CRED_SSL_SERVER_TRUST = 'svn.ssl.server';

  //SVN_AUTH_PARAM_PREFIX = 'svn:auth:';

  SVN_AUTH_SSL_NOTYETVALID = $00000001;
  SVN_AUTH_SSL_EXPIRED = $00000002;
  SVN_AUTH_SSL_CNMISMATCH = $00000004;
  SVN_AUTH_SSL_UNKNOWNCA = $00000008;
  SVN_AUTH_SSL_OTHER = $40000000;

  SVN_OPT_MAX_ALIASES = 3;
  SVN_OPT_MAX_OPTIONS = 50;
  SVN_OPT_FIRST_LONGOPT_ID = 256;

  SVN_VER_MAJOR = 1;
  SVN_VER_MINOR = 4;
  SVN_VER_PATCH = 3;
  SVN_VER_MICRO = SVN_VER_PATCH;
  SVN_VER_LIBRARY = SVN_VER_MAJOR;
  SVN_VER_TAG = ' (r23084)';
  SVN_VER_NUMTAG = '';
  SVN_VER_REVISION = 23084;

  SVN_RA_ABI_VERSION = 2;

  SVN_WC_TRANSLATE_FROM_NF = $00000000;
  SVN_WC_TRANSLATE_TO_NF = $00000001;
  SVN_WC_TRANSLATE_FORCE_EOL_REPAIR = $00000002;
  SVN_WC_TRANSLATE_NO_OUTPUT_CLEANUP = $00000004;
  SVN_WC_TRANSLATE_FORCE_COPY = $00000008;
  SVN_WC_TRANSLATE_USE_GLOBAL_TMP = $00000010;

  SVN_CLIENT_COMMIT_ITEM_ADD = $01;
  SVN_CLIENT_COMMIT_ITEM_DELETE = $02;
  SVN_CLIENT_COMMIT_ITEM_TEXT_MODS = $04;
  SVN_CLIENT_COMMIT_ITEM_PROP_MODS = $08;
  SVN_CLIENT_COMMIT_ITEM_IS_COPY = $10;
  SVN_CLIENT_COMMIT_ITEM_LOCK_TOKEN = $20;

  SVN_CLIENT_AUTH_USERNAME = 'username';
  SVN_CLIENT_AUTH_PASSWORD = 'password';

type
/////////////////////////////////////////////////


     psvn_auth_iterstate_t = ^svn_auth_iterstate_t;
     svn_auth_iterstate_t = record end;

     psvn_auth_provider_t = ^svn_auth_provider_t;
     svn_auth_provider_t = record
          cred_kind : pchar;
          first_credentials : function (credentials:ppointer; iter_baton:ppointer; provider_baton:pointer; parameters:papr_hash_t; realmstring:pchar;
                       pool:apr_pool_p):psvn_error_t;cdecl;
          next_credentials : function (credentials:ppointer; iter_baton:pointer; provider_baton:pointer; parameters:papr_hash_t; realmstring:pchar;
                       pool:apr_pool_p):psvn_error_t;
          save_credentials : function (saved:svn_boolean_p; credentials:pointer; provider_baton:pointer; parameters:papr_hash_t; realmstring:pchar;
                       pool:apr_pool_p):psvn_error_t;
       end;

     svn_auth_provider_object_p = ^svn_auth_provider_object_t;
     svn_auth_provider_object_t = record
          vtable : psvn_auth_provider_t;
          provider_baton : pointer;
       end;

     svn_auth_cred_simple_p = ^svn_auth_cred_simple_t;
     svn_auth_cred_simple_t = record
          username : pchar;
          password : pchar;
          may_save : svn_boolean_t;
       end;

     svn_auth_cred_username_p = ^svn_auth_cred_username_t;
     svn_auth_cred_username_t = record
          username : pchar;
          may_save : svn_boolean_t;
       end;

     psvn_auth_cred_ssl_client_cert_t = ^svn_auth_cred_ssl_client_cert_t;
     svn_auth_cred_ssl_client_cert_t = record
          cert_file : pchar;
          may_save : svn_boolean_t;
       end;

     psvn_auth_cred_ssl_client_cert_pw_t = ^svn_auth_cred_ssl_client_cert_pw_t;
     svn_auth_cred_ssl_client_cert_pw_t = record
          password : pchar;
          may_save : svn_boolean_t;
       end;

     psvn_auth_ssl_server_cert_info_t = ^svn_auth_ssl_server_cert_info_t;
     svn_auth_ssl_server_cert_info_t = record
          hostname : pchar;
          fingerprint : pchar;
          valid_from : pchar;
          valid_until : pchar;
          issuer_dname : pchar;
          ascii_cert : pchar;
       end;

     psvn_auth_cred_ssl_server_trust_t = ^svn_auth_cred_ssl_server_trust_t;
     svn_auth_cred_ssl_server_trust_t = record
          may_save : svn_boolean_t;
          accepted_failures : apr_uint32_t;
       end;

(** Set @a *cred by prompting the user, allocating @a *cred in @a pool.
 * @a baton is an implementation-specific closure.
 *
 * If @a realm is non-null, maybe use it in the prompt string.
 *
 * If @a username is non-null, then the user might be prompted only
 * for a password, but @a *cred would still be filled with both
 * username and password.  For example, a typical usage would be to
 * pass @a username on the first call, but then leave it null for
 * subsequent calls, on the theory that if credentials failed, it's
 * as likely to be due to incorrect username as incorrect password.
 *
 * If @a may_save is FALSE, the auth system does not allow the credentials
 * to be saved (to disk). A prompt function shall not ask the user if the
 * credentials shall be saved if @a may_save is FALSE. For example, a GUI
 * client with a remember password checkbox would grey out the checkbox if
 * @a may_save is FALSE.
 *)
  svn_auth_simple_prompt_func_p = ^svn_auth_simple_prompt_func_t;
  svn_auth_simple_prompt_func_t = function (
    out cred: svn_auth_cred_simple_p;
    baton: pointer;
    realm: pchar;
    username: pchar;
    may_save: svn_boolean_t;
    pool: apr_pool_p
  ): svn_error_p; cdecl;

(** Set @a *cred by prompting the user, allocating @a *cred in @a pool.
 * @a baton is an implementation-specific closure.
 *
 * If @a realm is non-null, maybe use it in the prompt string.
 *
 * If @a may_save is FALSE, the auth system does not allow the credentials
 * to be saved (to disk). A prompt function shall not ask the user if the
 * credentials shall be saved if @a may_save is FALSE. For example, a GUI
 * client with a remember username checkbox would grey out the checkbox if
 * @a may_save is FALSE.
 *)
  svn_auth_username_prompt_func_p = ^svn_auth_username_prompt_func_t;
  svn_auth_username_prompt_func_t = function (
    out cred: svn_auth_cred_username_p;
    baton: pointer;
    realm: pchar;
    may_save: svn_boolean_t;
    pool: apr_pool_p
  ): svn_error_p; cdecl;


     psvn_auth_ssl_server_trust_prompt_func_t = ^svn_auth_ssl_server_trust_prompt_func_t;
     svn_auth_ssl_server_trust_prompt_func_t = svn_error_t;


     psvn_auth_ssl_client_cert_prompt_func_t = ^svn_auth_ssl_client_cert_prompt_func_t;
     svn_auth_ssl_client_cert_prompt_func_t = svn_error_t;


     psvn_auth_ssl_client_cert_pw_prompt_func_t = ^svn_auth_ssl_client_cert_pw_prompt_func_t;
     svn_auth_ssl_client_cert_pw_prompt_func_t = svn_error_t;

     svn_string_p = ^svn_string_t;
     svn_string_t = record
          data : pchar;
          len : apr_size_t;
       end;

     psvn_stringbuf_t = ^svn_stringbuf_t;
     svn_stringbuf_p = ^svn_stringbuf_t;
     svn_stringbuf_t = record
          pool : apr_pool_p;
          data : pchar;
          len : apr_size_t;
          blocksize : apr_size_t;
       end;

     psvn_opt_subcommand_t = ^svn_opt_subcommand_t;
     svn_opt_subcommand_t = svn_error_t;

     psvn_opt_subcommand_desc2_t = ^svn_opt_subcommand_desc2_t;
     svn_opt_subcommand_desc2_t = record
          name : pchar;
          cmd_func : psvn_opt_subcommand_t;
          aliases : array[0..(SVN_OpT_MAX_ALIASES)-1] of pchar;
          help : pchar;
          valid_options : array[0..(SVN_OpT_MAX_OpTIONS)-1] of longint;
          desc_overrides : array[0..(SVN_OpT_MAX_OpTIONS)-1] of record
               optch : longint;
               desc : pchar;
            end;
       end;

     psvn_opt_subcommand_desc_t = ^svn_opt_subcommand_desc_t;
     svn_opt_subcommand_desc_t = record
          name : pchar;
          cmd_func : psvn_opt_subcommand_t;
          aliases : array[0..(SVN_OpT_MAX_ALIASES)-1] of pchar;
          help : pchar;
          valid_options : array[0..(SVN_OpT_MAX_OpTIONS)-1] of longint;
       end;

     svn_opt_revision_kind = (svn_opt_revision_unspecified,svn_opt_revision_number,
       svn_opt_revision_date,svn_opt_revision_committed,
       svn_opt_revision_previous,svn_opt_revision_base,
       svn_opt_revision_working,svn_opt_revision_head
       );



     psvn_opt_revision_value_t = ^svn_opt_revision_value_t;
     svn_opt_revision_value_t = record
         case longint of
            0 : ( number : svn_revnum_t );
            1 : ( date : apr_time_t );
         end;




  psvn_opt_revision_t = ^svn_opt_revision_t;
  svn_opt_revision_p = ^svn_opt_revision_t;
  svn_opt_revision_t = record
    kind: svn_opt_revision_kind;
    value: svn_opt_revision_value_t;
  end;

       psvn_version_t = ^svn_version_t;
       svn_version_t = record
            major : longint;
            minor : longint;
            patch : longint;
            tag : pchar;
         end;

       psvn_version_checklist_t = ^svn_version_checklist_t;
       svn_version_checklist_t = record
            _label : pchar;
            version_query : function :psvn_version_t;cdecl;
         end;

     psvn_diff_datasource_e = ^svn_diff_datasource_e;
     svn_diff_datasource_e = (svn_diff_datasource_original,svn_diff_datasource_modified,
       svn_diff_datasource_latest,svn_diff_datasource_ancestor
       );

     psvn_diff_fns_t = ^svn_diff_fns_t;
     svn_diff_fns_t = record
          datasource_open : function (diff_baton:pointer; datasource:svn_diff_datasource_e):psvn_error_t;cdecl;
          datasource_close : function (diff_baton:pointer; datasource:svn_diff_datasource_e):psvn_error_t;
          datasource_get_next_token : function (hash:papr_uint32_t; token:ppointer; diff_baton:pointer; datasource:svn_diff_datasource_e):psvn_error_t;
          token_compare : function (diff_baton:pointer; ltoken:pointer; rtoken:pointer; compare:plongint):psvn_error_t;
          token_discard : procedure (diff_baton:pointer; token:pointer);
          token_discard_all : procedure (diff_baton:pointer);
       end;

     psvn_diff_t = ^svn_diff_t;
     svn_diff_t = record end;

     psvn_diff_output_fns_t = ^svn_diff_output_fns_t;
     svn_diff_output_fns_t = record
          output_common : function (output_baton:pointer; original_start:apr_off_t; original_length:apr_off_t; modified_start:apr_off_t; modified_length:apr_off_t;
                       latest_start:apr_off_t; latest_length:apr_off_t):psvn_error_t;cdecl;
          output_diff_modified : function (output_baton:pointer; original_start:apr_off_t; original_length:apr_off_t; modified_start:apr_off_t; modified_length:apr_off_t;
                       latest_start:apr_off_t; latest_length:apr_off_t):psvn_error_t;
          output_diff_latest : function (output_baton:pointer; original_start:apr_off_t; original_length:apr_off_t; modified_start:apr_off_t; modified_length:apr_off_t;
                       latest_start:apr_off_t; latest_length:apr_off_t):psvn_error_t;
          output_diff_common : function (output_baton:pointer; original_start:apr_off_t; original_length:apr_off_t; modified_start:apr_off_t; modified_length:apr_off_t;
                       latest_start:apr_off_t; latest_length:apr_off_t):psvn_error_t;
          output_conflict : function (output_baton:pointer; original_start:apr_off_t; original_length:apr_off_t; modified_start:apr_off_t; modified_length:apr_off_t;
                       latest_start:apr_off_t; latest_length:apr_off_t; resolved_diff:psvn_diff_t):psvn_error_t;
       end;

     psvn_diff_file_ignore_space_t = ^svn_diff_file_ignore_space_t;
     svn_diff_file_ignore_space_t = (svn_diff_file_ignore_space_none,svn_diff_file_ignore_space_change,
       svn_diff_file_ignore_space_all);

     psvn_diff_file_options_t = ^svn_diff_file_options_t;
     svn_diff_file_options_t = record
          ignore_space : svn_diff_file_ignore_space_t;
          ignore_eol_style : svn_boolean_t;
       end;

     svn_delta_action = (svn_txdelta_source,svn_txdelta_target,
       svn_txdelta_new);

     psvn_txdelta_op_t = ^svn_txdelta_op_t;
     svn_txdelta_op_t = record
          action_code : svn_delta_action;
          offset : apr_size_t;
          length : apr_size_t;
       end;

     psvn_txdelta_window_t = ^svn_txdelta_window_t;
     svn_txdelta_window_t = record
          sview_offset : svn_filesize_t;
          sview_len : apr_size_t;
          tview_len : apr_size_t;
          num_ops : longint;
          src_ops : longint;
          ops : psvn_txdelta_op_t;
          new_data : svn_string_p;
       end;

     psvn_txdelta_window_handler_t = ^svn_txdelta_window_handler_t;
     svn_txdelta_window_handler_t = svn_error_t;



     psvn_txdelta_next_window_fn_t = ^svn_txdelta_next_window_fn_t;
     svn_txdelta_next_window_fn_t = svn_error_t;


     psvn_txdelta_md5_digest_fn_t = ^svn_txdelta_md5_digest_fn_t;
     svn_txdelta_md5_digest_fn_t = byte;

     psvn_delta_editor_t = ^svn_delta_editor_t;
     svn_delta_editor_t = record
          set_target_revision : function (edit_baton:pointer; target_revision:svn_revnum_t; pool:apr_pool_p):psvn_error_t;cdecl;
          open_root : function (edit_baton:pointer; base_revision:svn_revnum_t; dir_pool:apr_pool_p; root_baton:ppointer):psvn_error_t;
          delete_entry : function (path:pchar; revision:svn_revnum_t; parent_baton:pointer; pool:apr_pool_p):psvn_error_t;
          add_directory : function (path:pchar; parent_baton:pointer; copyfrom_path:pchar; copyfrom_revision:svn_revnum_t; dir_pool:apr_pool_p;
                       child_baton:ppointer):psvn_error_t;
          open_directory : function (path:pchar; parent_baton:pointer; base_revision:svn_revnum_t; dir_pool:apr_pool_p; child_baton:ppointer):psvn_error_t;
          change_dir_prop : function (dir_baton:pointer; name:pchar; value:svn_string_p; pool:apr_pool_p):psvn_error_t;
          close_directory : function (dir_baton:pointer; pool:apr_pool_p):psvn_error_t;
          absent_directory : function (path:pchar; parent_baton:pointer; pool:apr_pool_p):psvn_error_t;
          add_file : function (path:pchar; parent_baton:pointer; copy_path:pchar; copy_revision:svn_revnum_t; file_pool:apr_pool_p;
                       file_baton:ppointer):psvn_error_t;
          open_file : function (path:pchar; parent_baton:pointer; base_revision:svn_revnum_t; file_pool:apr_pool_p; file_baton:ppointer):psvn_error_t;
          apply_textdelta : function (file_baton:pointer; base_checksum:pchar; pool:apr_pool_p; handler:psvn_txdelta_window_handler_t; handler_baton:ppointer):psvn_error_t;
          change_file_prop : function (file_baton:pointer; name:pchar; value:svn_string_p; pool:apr_pool_p):psvn_error_t;
          close_file : function (file_baton:pointer; text_checksum:pchar; pool:apr_pool_p):psvn_error_t;
          absent_file : function (path:pchar; parent_baton:pointer; pool:apr_pool_p):psvn_error_t;
          close_edit : function (edit_baton:pointer; pool:apr_pool_p):psvn_error_t;
          abort_edit : function (edit_baton:pointer; pool:apr_pool_p):psvn_error_t;
       end;

     psvn_delta_path_driver_cb_func_t = ^svn_delta_path_driver_cb_func_t;
     svn_delta_path_driver_cb_func_t = svn_error_t;

     psvn_ra_get_wc_prop_func_t = ^svn_ra_get_wc_prop_func_t;
     svn_ra_get_wc_prop_func_t = svn_error_t;


     psvn_ra_set_wc_prop_func_t = ^svn_ra_set_wc_prop_func_t;
     svn_ra_set_wc_prop_func_t = svn_error_t;


     psvn_ra_push_wc_prop_func_t = ^svn_ra_push_wc_prop_func_t;
     svn_ra_push_wc_prop_func_t = svn_error_t;


     psvn_ra_invalidate_wc_props_func_t = ^svn_ra_invalidate_wc_props_func_t;
     svn_ra_invalidate_wc_props_func_t = svn_error_t;


     psvn_ra_get_latest_revnum_func_t = ^svn_ra_get_latest_revnum_func_t;
     svn_ra_get_latest_revnum_func_t = svn_error_t;


     psvn_ra_file_rev_handler_t = ^svn_ra_file_rev_handler_t;
     svn_ra_file_rev_handler_t = svn_error_t;


     psvn_ra_lock_callback_t = ^svn_ra_lock_callback_t;
     svn_ra_lock_callback_t = svn_error_t;

     psvn_ra_session_t = ^svn_ra_session_t;
     svn_ra_session_t = record end;

     svn_ra_progress_notify_func_t = procedure (progress:apr_off_t; total:apr_off_t; baton:pointer; pool:apr_pool_p);cdecl;

     psvn_ra_reporter2_t = ^svn_ra_reporter2_t;
     svn_ra_reporter2_t = record
          set_path : function (report_baton:pointer; path:pchar; revision:svn_revnum_t; start_empty:svn_boolean_t; lock_token:pchar;
                       pool:apr_pool_p):psvn_error_t;cdecl;
          delete_path : function (report_baton:pointer; path:pchar; pool:apr_pool_p):psvn_error_t;
          link_path : function (report_baton:pointer; path:pchar; url:pchar; revision:svn_revnum_t; start_empty:svn_boolean_t;
                       lock_token:pchar; pool:apr_pool_p):psvn_error_t;
          finish_report : function (report_baton:pointer; pool:apr_pool_p):psvn_error_t;
          abort_report : function (report_baton:pointer; pool:apr_pool_p):psvn_error_t;
       end;

     psvn_ra_reporter_t = ^svn_ra_reporter_t;
     svn_ra_reporter_t = record
          set_path : function (report_baton:pointer; path:pchar; revision:svn_revnum_t; start_empty:svn_boolean_t; pool:apr_pool_p):psvn_error_t;cdecl;
          delete_path : function (report_baton:pointer; path:pchar; pool:apr_pool_p):psvn_error_t;
          link_path : function (report_baton:pointer; path:pchar; url:pchar; revision:svn_revnum_t; start_empty:svn_boolean_t;
                       pool:apr_pool_p):psvn_error_t;
          finish_report : function (report_baton:pointer; pool:apr_pool_p):psvn_error_t;
          abort_report : function (report_baton:pointer; pool:apr_pool_p):psvn_error_t;
       end;

     psvn_auth_baton_t = ^svn_auth_baton_t;
     svn_auth_baton_t = record end;

     psvn_ra_callbacks2_t = ^svn_ra_callbacks2_t;
     svn_ra_callbacks2_t = record
          open_tmp_file : function (var fp:apr_file_p; callback_baton:pointer; pool:apr_pool_p):psvn_error_t;cdecl;
          auth_baton : psvn_auth_baton_t;
          get_wc_prop : svn_ra_get_wc_prop_func_t;
          set_wc_prop : svn_ra_set_wc_prop_func_t;
          push_wc_prop : svn_ra_push_wc_prop_func_t;
          invalidate_wc_props : svn_ra_invalidate_wc_props_func_t;
          progress_func : svn_ra_progress_notify_func_t;
          progress_baton : pointer;
       end;


     psvn_ra_callbacks_t = ^svn_ra_callbacks_t;
     svn_ra_callbacks_t = record
          open_tmp_file : function (var fp:apr_file_p; callback_baton:pointer; pool:apr_pool_p):psvn_error_t;cdecl;
          auth_baton : psvn_auth_baton_t;
          get_wc_prop : svn_ra_get_wc_prop_func_t;
          set_wc_prop : svn_ra_set_wc_prop_func_t;
          push_wc_prop : svn_ra_push_wc_prop_func_t;
          invalidate_wc_props : svn_ra_invalidate_wc_props_func_t;
       end;

(** An abstract stream of bytes--either incoming or outgoing or both.
 *
 * The creator of a stream sets functions to handle read and write.
 * Both of these handlers accept a baton whose value is determined at
 * stream creation time; this baton can point to a structure
 * containing data associated with the stream.  If a caller attempts
 * to invoke a handler which has not been set, it will generate a
 * runtime assertion failure.  The creator can also set a handler for
 * close requests so that it can flush buffered data or whatever;
 * if a close handler is not specified, a close request on the stream
 * will simply be ignored.  Note that svn_stream_close() does not
 * deallocate the memory used to allocate the stream structure; free
 * the pool you created the stream in to free that memory.
 *
 * The read and write handlers accept length arguments via pointer.
 * On entry to the handler, the pointed-to value should be the amount
 * of data which can be read or the amount of data to write.  When the
 * handler returns, the value is reset to the amount of data actually
 * read or written.  Handlers are obliged to complete a read or write
 * to the maximum extent possible; thus, a short read with no
 * associated error implies the end of the input stream, and a short
 * write should never occur without an associated error.
 *)
     svn_stream_p = ^svn_stream_t;
     svn_stream_t = record end;

     psvn_ra_plugin_t = ^svn_ra_plugin_t;
     svn_ra_plugin_t = record
          name : pchar;
          description : pchar;
          open : function (var session_baton:pointer; repos_URL:pchar; callbacks:psvn_ra_callbacks_t; callback_baton:pointer; config:papr_hash_t;
                       pool:apr_pool_p):psvn_error_t;cdecl;
          get_latest_revnum : function (session_baton:pointer; latest_revnum:svn_revnum_p; pool:apr_pool_p):psvn_error_t;
          get_dated_revision : function (session_baton:pointer; revision:svn_revnum_p; tm:apr_time_t; pool:apr_pool_p):psvn_error_t;
          change_rev_prop : function (session_baton:pointer; rev:svn_revnum_t; name:pchar; value:svn_string_p; pool:apr_pool_p):psvn_error_t;
          rev_proplist : function (session_baton:pointer; rev:svn_revnum_t; var props:papr_hash_t; pool:apr_pool_p):psvn_error_t;
          rev_prop : function (session_baton:pointer; rev:svn_revnum_t; name:pchar; var value:svn_string_p; pool:apr_pool_p):psvn_error_t;
          get_commit_editor : function (session_baton:pointer; var editor:psvn_delta_editor_t; var edit_baton:pointer; log_msg:pchar; callback:svn_commit_callback_t;
                       callback_baton:pointer; pool:apr_pool_p):psvn_error_t;
          get_file : function (session_baton:pointer; path:pchar; revision:svn_revnum_t; stream:svn_stream_p; fetched_rev:svn_revnum_p;
                       var props:papr_hash_t; pool:apr_pool_p):psvn_error_t;
          get_dir : function (session_baton:pointer; path:pchar; revision:svn_revnum_t; var dirents:papr_hash_t; fetched_rev:svn_revnum_p;
                       var props:papr_hash_t; pool:apr_pool_p):psvn_error_t;
          do_update : function (session_baton:pointer; var reporter:psvn_ra_reporter_t; var report_baton:pointer; revision_to_update_to:svn_revnum_t; update_target:pchar;
                       recurse:svn_boolean_t; update_editor:psvn_delta_editor_t; update_baton:pointer; pool:apr_pool_p):psvn_error_t;
          do_switch : function (session_baton:pointer; var reporter:psvn_ra_reporter_t; var report_baton:pointer; revision_to_switch_to:svn_revnum_t; switch_target:pchar;
                       recurse:svn_boolean_t; switch_url:pchar; switch_editor:psvn_delta_editor_t; switch_baton:pointer; pool:apr_pool_p):psvn_error_t;
          do_status : function (session_baton:pointer; var reporter:psvn_ra_reporter_t; var report_baton:pointer; status_target:pchar; revision:svn_revnum_t;
                       recurse:svn_boolean_t; status_editor:psvn_delta_editor_t; status_baton:pointer; pool:apr_pool_p):psvn_error_t;
          do_diff : function (session_baton:pointer; var reporter:psvn_ra_reporter_t; var report_baton:pointer; revision:svn_revnum_t; diff_target:pchar;
                       recurse:svn_boolean_t; ignore_ancestry:svn_boolean_t; versus_url:pchar; diff_editor:psvn_delta_editor_t; diff_baton:pointer;
                       pool:apr_pool_p):psvn_error_t;
          get_log : function (session_baton:pointer; paths:apr_array_header_p; start:svn_revnum_t; _end:svn_revnum_t; discover_changed_paths:svn_boolean_t;
                       strict_node_history:svn_boolean_t; receiver:svn_log_message_receiver_t; receiver_baton:pointer; pool:apr_pool_p):psvn_error_t;
          check_path : function (session_baton:pointer; path:pchar; revision:svn_revnum_t; kind:svn_node_kind_p; pool:apr_pool_p):psvn_error_t;
          get_uuid : function (session_baton:pointer; var uuid:pchar; pool:apr_pool_p):psvn_error_t;
          get_repos_root : function (session_baton:pointer; var url:pchar; pool:apr_pool_p):psvn_error_t;
          get_locations : function (session_baton:pointer; var locations:papr_hash_t; path:pchar; peg_revision:svn_revnum_t; location_revisions:apr_array_header_p;
                       pool:apr_pool_p):psvn_error_t;
          get_file_revs : function (session_baton:pointer; path:pchar; start:svn_revnum_t; _end:svn_revnum_t; handler:svn_ra_file_rev_handler_t;
                       handler_baton:pointer; pool:apr_pool_p):psvn_error_t;
          get_version : function :psvn_version_t;
       end;


     psvn_ra_init_func_t = ^svn_ra_init_func_t;
     svn_ra_init_func_t = svn_error_t;

     psvn_wc_external_item_t = ^svn_wc_external_item_t;
     svn_wc_external_item_t = record
          target_dir : pchar;
          url : pchar;
          revision : svn_opt_revision_t;
       end;

     psvn_wc_notify_action_t = ^svn_wc_notify_action_t;
     svn_wc_notify_action_t = (svn_wc_notify_add := 0,svn_wc_notify_copy,
       svn_wc_notify_delete,svn_wc_notify_restore,
       svn_wc_notify_revert,svn_wc_notify_failed_revert,
       svn_wc_notify_resolved,svn_wc_notify_skip,
       svn_wc_notify_update_delete,svn_wc_notify_update_add,
       svn_wc_notify_update_update,svn_wc_notify_update_completed,
       svn_wc_notify_update_external,svn_wc_notify_status_completed,
       svn_wc_notify_status_external,svn_wc_notify_commit_modified,
       svn_wc_notify_commit_added,svn_wc_notify_commit_deleted,
       svn_wc_notify_commit_replaced,svn_wc_notify_commit_postfix_txdelta,
       svn_wc_notify_blame_revision,svn_wc_notify_locked,
       svn_wc_notify_unlocked,svn_wc_notify_failed_lock,
       svn_wc_notify_failed_unlock);

     psvn_wc_notify_state_t = ^svn_wc_notify_state_t;
     svn_wc_notify_state_t = (svn_wc_notify_state_inapplicable := 0,
       svn_wc_notify_state_unknown,svn_wc_notify_state_unchanged,
       svn_wc_notify_state_missing,svn_wc_notify_state_obstructed,
       svn_wc_notify_state_changed,svn_wc_notify_state_merged,
       svn_wc_notify_state_conflicted);

     psvn_wc_notify_lock_state_t = ^svn_wc_notify_lock_state_t;
     svn_wc_notify_lock_state_t = (svn_wc_notify_lock_state_inapplicable := 0,
       svn_wc_notify_lock_state_unknown,svn_wc_notify_lock_state_unchanged,
       svn_wc_notify_lock_state_locked,svn_wc_notify_lock_state_unlocked
       );

     psvn_wc_notify_t = ^svn_wc_notify_t;
     svn_wc_notify_t = record
          path : pchar;
          action : svn_wc_notify_action_t;
          kind : svn_node_kind_t;
          mime_type : pchar;
          lock : svn_lock_p;
          err : psvn_error_t;
          content_state : svn_wc_notify_state_t;
          prop_state : svn_wc_notify_state_t;
          lock_state : svn_wc_notify_lock_state_t;
          revision : svn_revnum_t;
       end;

     psvn_wc_adm_access_t = ^svn_wc_adm_access_t;
     svn_wc_adm_access_t = record end;

     psvn_wc_diff_callbacks2_t = ^svn_wc_diff_callbacks2_t;
     svn_wc_diff_callbacks2_t = record
          file_changed : function (adm_access:psvn_wc_adm_access_t; contentstate:psvn_wc_notify_state_t; propstate:psvn_wc_notify_state_t; path:pchar; tmpfile1:pchar;
                       tmpfile2:pchar; rev1:svn_revnum_t; rev2:svn_revnum_t; mimetype1:pchar; mimetype2:pchar;
                       propchanges:apr_array_header_p; originalprops:papr_hash_t; diff_baton:pointer):psvn_error_t;cdecl;
          file_added : function (adm_access:psvn_wc_adm_access_t; contentstate:psvn_wc_notify_state_t; propstate:psvn_wc_notify_state_t; path:pchar; tmpfile1:pchar;
                       tmpfile2:pchar; rev1:svn_revnum_t; rev2:svn_revnum_t; mimetype1:pchar; mimetype2:pchar;
                       propchanges:apr_array_header_p; originalprops:papr_hash_t; diff_baton:pointer):psvn_error_t;
          file_deleted : function (adm_access:psvn_wc_adm_access_t; state:psvn_wc_notify_state_t; path:pchar; tmpfile1:pchar; tmpfile2:pchar;
                       mimetype1:pchar; mimetype2:pchar; originalprops:papr_hash_t; diff_baton:pointer):psvn_error_t;
          dir_added : function (adm_access:psvn_wc_adm_access_t; state:psvn_wc_notify_state_t; path:pchar; rev:svn_revnum_t; diff_baton:pointer):psvn_error_t;
          dir_deleted : function (adm_access:psvn_wc_adm_access_t; state:psvn_wc_notify_state_t; path:pchar; diff_baton:pointer):psvn_error_t;
          dir_props_changed : function (adm_access:psvn_wc_adm_access_t; state:psvn_wc_notify_state_t; path:pchar; propchanges:apr_array_header_p; original_props:papr_hash_t;
                       diff_baton:pointer):psvn_error_t;
       end;

     psvn_wc_diff_callbacks_t = ^svn_wc_diff_callbacks_t;
     svn_wc_diff_callbacks_t = record
          file_changed : function (adm_access:psvn_wc_adm_access_t; state:psvn_wc_notify_state_t; path:pchar; tmpfile1:pchar; tmpfile2:pchar;
                       rev1:svn_revnum_t; rev2:svn_revnum_t; mimetype1:pchar; mimetype2:pchar; diff_baton:pointer):psvn_error_t;cdecl;
          file_added : function (adm_access:psvn_wc_adm_access_t; state:psvn_wc_notify_state_t; path:pchar; tmpfile1:pchar; tmpfile2:pchar;
                       rev1:svn_revnum_t; rev2:svn_revnum_t; mimetype1:pchar; mimetype2:pchar; diff_baton:pointer):psvn_error_t;
          file_deleted : function (adm_access:psvn_wc_adm_access_t; state:psvn_wc_notify_state_t; path:pchar; tmpfile1:pchar; tmpfile2:pchar;
                       mimetype1:pchar; mimetype2:pchar; diff_baton:pointer):psvn_error_t;
          dir_added : function (adm_access:psvn_wc_adm_access_t; state:psvn_wc_notify_state_t; path:pchar; rev:svn_revnum_t; diff_baton:pointer):psvn_error_t;
          dir_deleted : function (adm_access:psvn_wc_adm_access_t; state:psvn_wc_notify_state_t; path:pchar; diff_baton:pointer):psvn_error_t;
          props_changed : function (adm_access:psvn_wc_adm_access_t; state:psvn_wc_notify_state_t; path:pchar; propchanges:apr_array_header_p; original_props:papr_hash_t;
                       diff_baton:pointer):psvn_error_t;
       end;

     psvn_wc_schedule_t = ^svn_wc_schedule_t;
     svn_wc_schedule_t = (svn_wc_schedule_normal,svn_wc_schedule_add,
       svn_wc_schedule_delete,svn_wc_schedule_replace
       );

     psvn_wc_entry_t = ^svn_wc_entry_t;
     svn_wc_entry_t = record
          name : pchar;
          revision : svn_revnum_t;
          url : pchar;
          repos : pchar;
          uuid : pchar;
          kind : svn_node_kind_t;
          schedule : svn_wc_schedule_t;
          copied : svn_boolean_t;
          deleted : svn_boolean_t;
          absent : svn_boolean_t;
          incomplete : svn_boolean_t;
          copyfrom_url : pchar;
          copyfrom_rev : svn_revnum_t;
          conflict_old : pchar;
          conflict_new : pchar;
          conflict_wrk : pchar;
          prejfile : pchar;
          text_time : apr_time_t;
          prop_time : apr_time_t;
          checksum : pchar;
          cmt_rev : svn_revnum_t;
          cmt_date : apr_time_t;
          cmt_author : pchar;
          lock_token : pchar;
          lock_owner : pchar;
          lock_comment : pchar;
          lock_creation_date : apr_time_t;
          has_props : svn_boolean_t;
          has_prop_mods : svn_boolean_t;
          cachable_props : pchar;
          present_props : pchar;
       end;

     psvn_wc_entry_callbacks_t = ^svn_wc_entry_callbacks_t;
     svn_wc_entry_callbacks_t = record
          found_entry : function (path:pchar; entry:psvn_wc_entry_t; walk_baton:pointer; pool:apr_pool_p):psvn_error_t;cdecl;
       end;

     svn_wc_status_kind = (svn_wc_status_none := 1,svn_wc_status_unversioned,
       svn_wc_status_normal,svn_wc_status_added,
       svn_wc_status_missing,svn_wc_status_deleted,
       svn_wc_status_replaced,svn_wc_status_modified,
       svn_wc_status_merged,svn_wc_status_conflicted,
       svn_wc_status_ignored,svn_wc_status_obstructed,
       svn_wc_status_external,svn_wc_status_incomplete
       );

     psvn_wc_status2_t = ^svn_wc_status2_t;
     svn_wc_status2_t = record
          entry : psvn_wc_entry_t;
          text_status : svn_wc_status_kind;
          prop_status : svn_wc_status_kind;
          locked : svn_boolean_t;
          copied : svn_boolean_t;
          switched : svn_boolean_t;
          repos_text_status : svn_wc_status_kind;
          repos_prop_status : svn_wc_status_kind;
          repos_lock : svn_lock_p;
          url : pchar;
          ood_last_cmt_rev : svn_revnum_t;
          ood_last_cmt_date : apr_time_t;
          ood_kind : svn_node_kind_t;
          ood_last_cmt_author : pchar;
       end;

     psvn_wc_status_t = ^svn_wc_status_t;
     svn_wc_status_t = record
          entry : psvn_wc_entry_t;
          text_status : svn_wc_status_kind;
          prop_status : svn_wc_status_kind;
          locked : svn_boolean_t;
          copied : svn_boolean_t;
          switched : svn_boolean_t;
          repos_text_status : svn_wc_status_kind;
          repos_prop_status : svn_wc_status_kind;
       end;

     svn_wc_status_func2_t = procedure (baton:pointer; path:pchar; status:psvn_wc_status2_t);cdecl;

     svn_wc_status_func_t = procedure (baton:pointer; path:pchar; status:psvn_wc_status_t);cdecl;

     psvn_wc_merge_outcome_t = ^svn_wc_merge_outcome_t;
     svn_wc_merge_outcome_t = (svn_wc_merge_unchanged,svn_wc_merge_merged,
       svn_wc_merge_conflict,svn_wc_merge_no_merge
       );

     psvn_wc_relocation_validator2_t = ^svn_wc_relocation_validator2_t;
     svn_wc_relocation_validator2_t = svn_error_t;


     psvn_wc_relocation_validator_t = ^svn_wc_relocation_validator_t;
     svn_wc_relocation_validator_t = svn_error_t;

     psvn_wc_revision_status_t = ^svn_wc_revision_status_t;
     svn_wc_revision_status_t = record
          min_rev : svn_revnum_t;
          max_rev : svn_revnum_t;
          switched : svn_boolean_t;
          modified : svn_boolean_t;
       end;

     psvn_client_proplist_item_t = ^svn_client_proplist_item_t;
     svn_client_proplist_item_t = record
          node_name : psvn_stringbuf_t;
          prop_hash : papr_hash_t;
       end;

     psvn_client_commit_info_t = ^svn_client_commit_info_t;
     svn_client_commit_info_t = record
          revision : svn_revnum_t;
          date : pchar;
          author : pchar;
       end;

     psvn_client_commit_item2_t = ^svn_client_commit_item2_t;
     svn_client_commit_item2_t = record
          path : pchar;
          kind : svn_node_kind_t;
          url : pchar;
          revision : svn_revnum_t;
          copyfrom_url : pchar;
          copyfrom_rev : svn_revnum_t;
          state_flags : apr_byte_t;
          wcprop_changes : apr_array_header_p;
       end;

     psvn_client_commit_item_t = ^svn_client_commit_item_t;
     svn_client_commit_item_t = record
          path : pchar;
          kind : svn_node_kind_t;
          url : pchar;
          revision : svn_revnum_t;
          copyfrom_url : pchar;
          state_flags : apr_byte_t;
          wcprop_changes : apr_array_header_p;
       end;


(** Callback type used by commit-y operations to get a commit log message
 * from the caller.
 *  
 * Set @a *log_msg to the log message for the commit, allocated in @a 
 * pool, or @c NULL if wish to abort the commit process.  Set @a *tmp_file 
 * to the path of any temporary file which might be holding that log 
 * message, or @c NULL if no such file exists (though, if @a *log_msg is 
 * @c NULL, this value is undefined).  The log message MUST be a UTF8 
 * string with LF line separators.
 *
 * @a commit_items is a read-only array of @c svn_client_commit_item2_t
 * structures, which may be fully or only partially filled-in,
 * depending on the type of commit operation.
 *
 * @a baton is provided along with the callback for use by the handler.
 *
 * All allocations should be performed in @a pool.
 *
 * @since New in 1.3.
 *)
     svn_client_get_commit_log2_p = ^svn_client_get_commit_log2_t;
     svn_client_get_commit_log2_t = function (
       var log_msg: pchar;
       var tmp_file: pchar;
       commit_items: apr_array_header_p;
       baton: pointer;
       pool: apr_pool_p
     ): svn_error_p; cdecl;
     
     psvn_client_get_commit_log_t = ^svn_client_get_commit_log_t;
     svn_client_get_commit_log_t = svn_error_t;


     psvn_client_blame_receiver_t = ^svn_client_blame_receiver_t;
     svn_client_blame_receiver_t = svn_error_t;


     psvn_client_diff_summarize_kind_t = ^svn_client_diff_summarize_kind_t;
     svn_client_diff_summarize_kind_t = (svn_client_diff_summarize_kind_normal,
       svn_client_diff_summarize_kind_added,
       svn_client_diff_summarize_kind_modified,
       svn_client_diff_summarize_kind_deleted
       );

     psvn_client_diff_summarize_t = ^svn_client_diff_summarize_t;
     svn_client_diff_summarize_t = record
          path : pchar;
          summarize_kind : svn_client_diff_summarize_kind_t;
          prop_changed : svn_boolean_t;
          node_kind : svn_node_kind_t;
       end;

     psvn_client_diff_summarize_func_t = ^svn_client_diff_summarize_func_t;
     svn_client_diff_summarize_func_t = svn_error_t;


     svn_wc_notify_func2_t = procedure (baton: pointer;
       notify: svn_wc_notify_t; pool: apr_pool_p); cdecl;

     svn_wc_notify_func_t = procedure (baton: pointer;
       path: pchar; action: svn_wc_notify_action_t;
       kind: svn_node_kind_t; mime_type: pchar;
       content_state: svn_wc_notify_state_t;
       prop_state: svn_wc_notify_state_t;
       revision: svn_revnum_t); cdecl;
  
  psvn_client_ctx_t = ^svn_client_ctx_t;
  svn_client_ctx_p = ^svn_client_ctx_t;
  svn_client_ctx_t = record
    auth_baton: psvn_auth_baton_t;
    notify_func: svn_wc_notify_func_t;
    notify_baton: pointer;
    log_msg_func: svn_client_get_commit_log_t;
    log_msg_baton: pointer;
    config: papr_hash_t;
    cancel_func: svn_cancel_func_t;
    cancel_baton: pointer;
    notify_func2: svn_wc_notify_func2_t;
    notify_baton2: pointer;
    log_msg_func2: svn_client_get_commit_log2_t;
    log_msg_baton2: pointer;
    progress_func: svn_ra_progress_notify_func_t;
    progress_baton: pointer;
  end;

{** Invoked by svn_client_list() for each @a path with its @a dirent and,
 * if @a path is locked, its @a lock.  @a abs_path is the filesystem path
 * to which @a path is relative.  @a baton is the baton passed to the
 * caller.  @a pool may be used for temporary allocations.
 *
 * @since New in 1.4.
 *}
  svn_client_list_func_p = ^svn_client_list_func_t;
  svn_client_list_func_t = function (
    baton: pointer;
    path: pchar;
    dirent: svn_dirent_p;
    lock: svn_lock_p;
    abs_path: pchar;
    pool: apr_pool_p
  ): svn_error_p; cdecl;

(**
 * A structure which describes various system-generated metadata about
 * a working-copy path or URL.
 *
 * @note Fields may be added to the end of this structure in future
 * versions.  Therefore, users shouldn't allocate structures of this
 * type, to preserve binary compatibility.
 *
 * @since New in 1.2.
 *)
  svn_info_p = ^svn_info_t;
  svn_info_t = record
  (** Where the item lives in the repository. *)
    URL: pchar;
  (** The revision of the object.  If path_or_url is a working-copy
   * path, then this is its current working revnum.  If path_or_url
   * is a URL, then this is the repos revision that path_or_url lives in. *)
    rev: svn_revnum_t;
  (** The node's kind. *)
    kind: svn_node_kind_t;
  (** The root URL of the repository. *)
    repos_root_URL: pchar;
  (** The repository's UUID. *)
    repos_UUID: pchar;
  (** The last revision in which this object changed. *)
    last_changed_rev: svn_revnum_t;
  (** The date of the last_changed_rev. *)
    last_changed_date: apr_time_t;
  (** The author of the last_changed_rev. *)
    last_changed_author: pchar;
  (** An exclusive lock, if present.  Could be either local or remote. *)
    lock: svn_lock_p;
  (** Whether or not to ignore the next 10 wc-specific fields. *)
    has_wc_info: svn_boolean_t;
    
  (**
   * @name Working-copy path fields
   * These things only apply to a working-copy path.
   * See svn_wc_entry_t for explanations.
   * @{
   *)
    schedule: svn_wc_schedule_t;
    copyfrom_url: pchar;
    copyfrom_rev: svn_revnum_t;
    text_time: apr_time_t;
    prop_time: apr_time_t;
    checksum: pchar;
    conflict_old: pchar;
    conflict_new: pchar;
    conflict_wrk: pchar;
    prejfile: pchar;
  end;


(**
 * The callback invoked by svn_client_info().  Each invocation
 * describes @a path with the information present in @a info.  Note
 * that any fields within @a info may be NULL if information is
 * unavailable.  Use @a pool for all temporary allocation.
 *
 * @since New in 1.2.
 *)
     svn_info_receiver_p = ^svn_info_receiver_t;
     svn_info_receiver_t = function (
       baton: pointer;
       path: pchar;
       info: svn_info_p;
       pool: apr_pool_p
     ): svn_error_p; cdecl;
