
(******************************************************************************
    
  Subversion Client API for FreePascal

  @file svn_cmdline.h
  @brief Support functions for command line programs
     
  Note: I'm expect what it is very buggy... be careful ;)

  Zolotov Alex, 2007-2008
  zolotov-alex@shamangrad.net
  http://shamangrad.net/

 *****************************************************************************)

  {* Set up the locale for character conversion, and initialize APR.
   * If @a error_stream is non-null, print error messages to the stream,
   * using @a progname as the program name. Return @c EXIT_SUCCESS if
   * successful, otherwise @c EXIT_FAILURE.
   *
   * @note This function should be called exactly once at program startup,
   *       before calling any other APR or Subversion functions.
    }

  function svn_cmdline_init(progname: pchar; error_stream: pFILE): longint; cdecl; external libsvn_subr name 'svn_cmdline_init';

  {* Set @a *dest to an output-encoded C string from UTF-8 C string @a
   * src; allocate @a *dest in @a pool.
    }
  function svn_cmdline_cstring_from_utf8(out dest: pchar; src:pchar; pool:apr_pool_p): psvn_error_t; cdecl; external libsvn_subr name 'svn_cmdline_cstring_from_utf8';

  {* Like svn_utf_cstring_from_utf8_fuzzy(), but converts to an
   * output-encoded C string.  }
  function svn_cmdline_cstring_from_utf8_fuzzy(src:pchar; pool:apr_pool_p): pchar; cdecl; external libsvn_subr name 'svn_cmdline_cstring_from_utf8_fuzzy';

  {* Set @a *dest to a UTF-8-encoded C string from input-encoded C
   * string @a src; allocate @a *dest in @a pool.
    }
  function svn_cmdline_cstring_to_utf8(out dest: pchar; src:pchar; pool:apr_pool_p): psvn_error_t; cdecl; external libsvn_subr name 'svn_cmdline_cstring_to_utf8';

  {* Set @a *dest to an output-encoded natively-formatted path string
   * from canonical path @a src; allocate @a *dest in @a pool.
    }
  function svn_cmdline_path_local_style_from_utf8(out dest: pchar; src:pchar; pool:apr_pool_p): psvn_error_t; cdecl; external libsvn_subr name 'svn_cmdline_path_local_style_from_utf8';

  {* Write to stdout, using a printf-like format string @a fmt, passed
   * through apr_pvsprintf().  All string arguments are in UTF-8; the output
   * is converted to the output encoding.  Use @a pool for temporary
   * allocation.
   *
   * @since New in 1.1.
    }

  {* Write to the stdio @a stream, using a printf-like format string @a fmt,
   * passed through apr_pvsprintf().  All string arguments are in UTF-8;
   * the output is converted to the output encoding.  Use @a pool for
   * temporary allocation.
   *
   * @since New in 1.1.
    }
  {* Output the @a string to the stdio @a stream, converting from UTF-8
   * to the output encoding.  Use @a pool for temporary allocation.
   *
   * @since New in 1.1.
    }
  function svn_cmdline_fputs(_string: pchar; stream: pFILE; pool: apr_pool_p): psvn_error_t; cdecl; external libsvn_subr name 'svn_cmdline_fputs';

  {* Flush output buffers of the stdio @a stream, returning an error if that
   * fails.  This is just a wrapper for the standard fflush() function for
   * consistent error handling. 
   *
   * @since New in 1.1.
    }
  function svn_cmdline_fflush(stream: pFILE): psvn_error_t; cdecl; external libsvn_subr name 'svn_cmdline_fflush';

  {* Return the name of the output encoding allocated in @a pool, or @c
   * APR_LOCALE_CHARSET if the output encoding is the same as the locale
   * encoding.
   *
   * @since New in 1.3.
    }
  function svn_cmdline_output_encoding(pool: apr_pool_p): pchar; cdecl; external libsvn_subr name 'svn_cmdline_output_encoding';

  {* Handle @a error in preparation for immediate exit from a
   * command-line client.  Specifically:
   *
   * Call svn_handle_error2(@a error, stderr, FALSE, @a prefix), clear
   * @a error, destroy @a pool iff it is non-NULL, and return EXIT_FAILURE.
   *
   * @since New in 1.3.
    }
  function svn_cmdline_handle_exit_error(error: psvn_error_t; pool: apr_pool_p; prefix: pchar): longint; cdecl; external libsvn_subr name 'svn_cmdline_handle_exit_error';

  {* Prompt the user for input, using @a prompt_str for the prompt and
   * returning the user's response in @a result, allocated in @a pool.
   *
   * @since New in 1.4.
    }
  function svn_cmdline_prompt_user(out result: pchar; prompt_str: pchar; pool: apr_pool_p): psvn_error_t; cdecl; external libsvn_subr name 'svn_cmdline_prompt_user';

  {* A cancellation function/baton pair to be passed as the baton argument
   * to the @c svn_cmdline_*_prompt functions.
   *
   * @since New in 1.4.
    }

type
  svn_cmdline_prompt_baton_t = record
    cancel_func: svn_cancel_func_t;
    cancel_baton: pointer;
  end;

  {* An implementation of @c svn_auth_simple_prompt_func_t that prompts
   * the user for keyboard input on the command line.
   *
   * @since New in 1.4.
   *
   * Expects a @c svn_cmdline_prompt_baton_t to be passed as @a baton.
    }
  function svn_cmdline_auth_simple_prompt(out cred_p: svn_auth_cred_simple_p; baton: pointer; realm: pchar; username: pchar; may_save: svn_boolean_t;
    pool: apr_pool_p): psvn_error_t; cdecl; external libsvn_subr name 'svn_cmdline_auth_simple_prompt';

  {* An implementation of @c svn_auth_username_prompt_func_t that prompts
   * the user for their username via the command line.
   *
   * @since New in 1.4.
   *
   * Expects a @c svn_cmdline_prompt_baton_t to be passed as @a baton.
    }
  function svn_cmdline_auth_username_prompt(out cred_p: svn_auth_cred_username_p; baton: pointer; realm: pchar; may_save: svn_boolean_t; pool: apr_pool_p): psvn_error_t; cdecl; external libsvn_subr name 'svn_cmdline_auth_username_prompt';

  {* An implementation of @c svn_auth_ssl_server_trust_prompt_func_t that
   * asks the user if they trust a specific ssl server via the command line.
   *
   * @since New in 1.4.
   *
   * Expects a @c svn_cmdline_prompt_baton_t to be passed as @a baton.
    }
  function svn_cmdline_auth_ssl_server_trust_prompt(out cred_p: psvn_auth_cred_ssl_server_trust_t; baton:pointer; realm:pchar; failures:apr_uint32_t; cert_info:psvn_auth_ssl_server_cert_info_t;
             may_save:svn_boolean_t; pool:apr_pool_p):psvn_error_t; cdecl; external libsvn_subr name 'svn_cmdline_auth_ssl_server_trust_prompt';

  {* An implementation of @c svn_auth_ssl_client_cert_prompt_func_t that
   * prompts the user for the filename of their SSL client certificate via
   * the command line.
   *
   * @since New in 1.4.
   *
   * Expects a @c svn_cmdline_prompt_baton_t to be passed as @a baton.
    }
  function svn_cmdline_auth_ssl_client_cert_prompt(var cred_p:psvn_auth_cred_ssl_client_cert_t; baton:pointer; realm:pchar; may_save:svn_boolean_t; pool:apr_pool_p):psvn_error_t; cdecl; external libsvn_subr name 'svn_cmdline_auth_ssl_client_cert_prompt';

  {* An implementation of @c svn_auth_ssl_client_cert_pw_prompt_func_t that
   * prompts the user for their SSL certificate password via the command line.
   *
   * @since New in 1.4.
   *
   * Expects a @c svn_cmdline_prompt_baton_t to be passed as @a baton.
    }
  function svn_cmdline_auth_ssl_client_cert_pw_prompt(var cred_p:psvn_auth_cred_ssl_client_cert_pw_t; baton:pointer; realm:pchar; may_save:svn_boolean_t; pool:apr_pool_p):psvn_error_t; cdecl; external libsvn_subr name 'svn_cmdline_auth_ssl_client_cert_pw_prompt';

  {* Initialize auth baton @a ab with the standard set of authentication
   * providers used by the command line client.  @a non_interactive,
   * @a username, @a password, @a config_dir, and @a auth_cache are the 
   * values of the command line options of the same names.  @a cfg is the
   * @c SVN_CONFIG_CATEGORY_CONFIG configuration, and @a cancel_func and
   * @a cancel_baton control the cancellation of the prompting providers
   * that are initialized.  @a pool is used for all allocations.
   *
   * @since New in 1.4.
    }
  function svn_cmdline_setup_auth_baton(var ab:psvn_auth_baton_t; non_interactive:svn_boolean_t; username:pchar; password:pchar; config_dir:pchar;
             no_auth_cache:svn_boolean_t; cfg:psvn_config_t; cancel_func:svn_cancel_func_t; cancel_baton:pointer; pool:apr_pool_p):psvn_error_t; cdecl; external libsvn_subr name 'svn_cmdline_setup_auth_baton';

  {* Wrapper for apr_getopt_init(), which see.
   *
   * @since New in 1.4.
   * 
   * On OS400 V5R4, prior to calling apr_getopt_init(), converts each of the
   * @a argc strings in @a argv[] in place from EBCDIC to UTF-8, allocating
   * each new UTF-8 string in @a pool.
   *
   * This is a private API for Subversion's own use.
    }
  function svn_cmdline__getopt_init(var os:papr_getopt_t; argc:longint; argv:array of pchar; pool:apr_pool_p):psvn_error_t; cdecl; external libsvn_subr name 'svn_cmdline__getopt_init';
