
(******************************************************************************
    
  Subversion Client API for FreePascal

  Note: I'm expect what it is very buggy... be careful ;)

  Zolotov Alex, 2007-2008
  zolotov-alex@shamangrad.net
  http://shamangrad.net/

 *****************************************************************************)
  
type
  {* Used as an argument when creating temporary files to indicate
   * when a file should be removed.
   *
   * @since New in 1.4.
   *
   * Not specifying any of these means no removal at all.  }
  {* No deletion ever  }
  {* Remove when the file is closed  }
  {* Remove when the associated pool is cleared  }

  svn_io_file_del_p = ^svn_io_file_del_t;
  svn_io_file_del_t = (
    svn_io_file_del_none := 0,
    svn_io_file_del_on_close,
    svn_io_file_del_on_pool_cleanup
  );
  
  {* Represents the kind and special status of a directory entry.
   *
   * @since New in 1.3.
    }
  {* The kind of this entry.  }
  {* If @c kind is @c svn_node_file, whether this entry is a special file;
     * else false.
     *
     * @see svn_io_check_special_path().
      }
  svn_io_dirent_p = ^svn_io_dirent_t;
  svn_io_dirent_t = record
    kind: svn_node_kind_t;
    special: svn_boolean_t;
  end;

  {* Determine the @a kind of @a path.
   *
   * If utf8-encoded @a path exists, set @a *kind to the appropriate kind,
   * else set it to @c svn_node_unknown. 
   *
   * If @a path is a file, @a *kind is set to @c svn_node_file.
   *
   * If @a path is a directory, @a *kind is set to @c svn_node_dir.
   *
   * If @a path does not exist in its final component, @a *kind is set to
   * @c svn_node_none.  
   *
   * If intermediate directories on the way to @a path don't exist, an
   * error is returned, and @a *kind's value is undefined.
    }
  function svn_io_check_path(path:pchar; kind:svn_node_kind_p; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_check_path';

  {*
   * Like svn_io_check_path(), but also set *is_special to @c TRUE if
   * the path is not a normal file.
   *
   * @since New in 1.1.
    }
  function svn_io_check_special_path(path:pchar; kind:svn_node_kind_p; is_special:svn_boolean_p; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_check_special_path';

  {* Like svn_io_check_path(), but resolve symlinks.  This returns the
      same varieties of @a kind as svn_io_check_path().  }(* Const before type ignored *)
  function svn_io_check_resolved_path(path:pchar; kind:svn_node_kind_p; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_check_resolved_path';

  {* Open a new file (for writing) with a unique name based on utf-8
   * encoded @a path, in the same directory as @a path.  The file handle is
   * returned in @a *f, and the name, which ends with @a suffix, is returned
   * in @a *unique_name_p, also utf8-encoded.  Either @a f or @a unique_name_p
   * may be @c NULL.
   *
   * If @a delete_when is @c svn_io_file_del_on_close, then the @c APR_DELONCLOSE
   * flag will be used when opening the file.  The @c APR_BUFFERED flag will
   * always be used.
   *
   * The first attempt will just append @a suffix.  If the result is not
   * a unique name, then subsequent attempts will append a dot,
   * followed by an iteration number ("2", then "3", and so on),
   * followed by the suffix.  For example, if @a path is
   *
   *    tests/t1/A/D/G/pi
   *
   * then successive calls to
   *
   *    svn_io_open_unique_file2(&f, &unique_name, @a path, ".tmp", ..., pool)
   *
   * will open
   *
   *    tests/t1/A/D/G/pi.tmp
   *    tests/t1/A/D/G/pi.2.tmp
   *    tests/t1/A/D/G/pi.3.tmp
   *    tests/t1/A/D/G/pi.4.tmp
   *    tests/t1/A/D/G/pi.5.tmp
   *    ...
   *
   * Assuming @a suffix is non-empty, @a *unique_name_p will never be exactly
   * the same as @a path, even if @a path does not exist.
   *
   * It doesn't matter if @a path is a file or directory, the unique name will
   * be in @a path's parent either way.
   *
   * Allocate @a *f and @a *unique_name_p in @a pool.
   *
   * If no unique name can be found, @c SVN_ERR_IO_UNIQUE_NAMES_EXHAUSTED is
   * the error returned.
   *
   * Claim of Historical Inevitability: this function was written
   * because
   *
   *    - tmpnam() is not thread-safe.
   *    - tempname() tries standard system tmp areas first.
   *
   *
   * @since New in 1.4
   *
    }
  function svn_io_open_unique_file2(out f: apr_file_p; unique_name_p:Ppchar; path:pchar; suffix:pchar; delete_when:svn_io_file_del_t; 
             pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_open_unique_file2';

  {* Like svn_io_open_unique_file2, but can't delete on pool cleanup.
   *
   * @deprecated Provided for backward compatibility with the 1.0 API
   *
   * @note In 1.4 the API was extended to require either @a f or
   *       @a unique_name_p (the other can be NULL).  Before that, both were
   *       required.
   *
    }
  function svn_io_open_unique_file(out f: apr_file_p; unique_name_p:Ppchar; path:pchar; suffix:pchar; delete_on_close:svn_boolean_t; 
             pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_open_unique_file';

  {*
   * Like svn_io_open_unique_file(), except that instead of creating a
   * file, a symlink is generated that references the path @a dest.
   *
   * @since New in 1.1.
    }
  function svn_io_create_unique_link(unique_name_p:Ppchar; path:pchar; dest:pchar; suffix:pchar; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_create_unique_link';

  {*
   * Set @a *dest to the path that the symlink at @a path references.
   * Allocate the string from @a pool.
   *
   * @since New in 1.1.
    }
  function svn_io_read_link(out dest: svn_string_p; path:pchar; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_read_link';

  {* Set @a *dir to a directory path (allocated in @a pool) deemed
   * usable for the creation of temporary files and subdirectories.
    }
  function svn_io_temp_dir(dir:Ppchar; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_temp_dir';

  {* Copy @a src to @a dst atomically, in a "byte-for-byte" manner.
   * Overwrite @a dst if it exists, else create it.  Both @a src and @a dst
   * are utf8-encoded filenames.  If @a copy_perms is true, set @a dst's
   * permissions to match those of @a src.
    }
  function svn_io_copy_file(src:pchar; dst:pchar; copy_perms:svn_boolean_t; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_copy_file';

  {*
   * Copy symbolic link @a src to @a dst atomically.  Overwrite @a dst
   * if it exists, else create it.  Both @a src and @a dst are
   * utf8-encoded filenames.  After copying, the @a dst link will point
   * to the same thing @a src does.
   * 
   * @since New in 1.1.
    }
  function svn_io_copy_link(src:pchar; dst:pchar; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_copy_link';

  {* Recursively copy directory @a src into @a dst_parent, as a new entry named
   * @a dst_basename.  If @a dst_basename already exists in @a dst_parent, 
   * return error.  @a copy_perms will be passed through to svn_io_copy_file()
   * when any files are copied.  @a src, @a dst_parent, and @a dst_basename are 
   * all utf8-encoded.
   *
   * If @a cancel_func is non-null, invoke it with @a cancel_baton at
   * various points during the operation.  If it returns any error
   * (typically @c SVN_ERR_CANCELLED), return that error immediately.
    }(* Const before type ignored *)
  function svn_io_copy_dir_recursively(src:pchar; dst_parent:pchar; dst_basename:pchar; copy_perms:svn_boolean_t; cancel_func:svn_cancel_func_t; 
             cancel_baton:pointer; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_copy_dir_recursively';

  {* Create directory @a path on the file system, creating intermediate
   * directories as required, like <tt>mkdir -p</tt>.  Report no error if @a 
   * path already exists.  @a path is utf8-encoded.
   *
   * This is essentially a wrapper for apr_dir_make_recursive(), passing
   * @c APR_OS_DEFAULT as the permissions.
    }
  function svn_io_make_dir_recursively(path:pchar; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_make_dir_recursively';

  {* Set @a *is_empty_p to @c TRUE if directory @a path is empty, else to 
   * @c FALSE if it is not empty.  @a path must be a directory, and is
   * utf8-encoded.  Use @a pool for temporary allocation.
    }
  function svn_io_dir_empty(is_empty_p:svn_boolean_p; path:pchar; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_dir_empty';

  {* Append @a src to @a dst.  @a dst will be appended to if it exists, else it
   * will be created.  Both @a src and @a dst are utf8-encoded.
    }
  function svn_io_append_file(src:pchar; dst:pchar; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_append_file';

  {* Make a file as read-only as the operating system allows.
   * @a path is the utf8-encoded path to the file. If @a ignore_enoent is
   * @c TRUE, don't fail if the target file doesn't exist.
    }
  function svn_io_set_file_read_only(path:pchar; ignore_enoent:svn_boolean_t; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_set_file_read_only';

  {* Make a file as writable as the operating system allows.
   * @a path is the utf8-encoded path to the file.  If @a ignore_enoent is
   * @c TRUE, don't fail if the target file doesn't exist.
   * @warning On Unix this function will do the equivalent of chmod a+w path.
   * If this is not what you want you should not use this function, but rather
   * use apr_file_perms_set().
    }
  function svn_io_set_file_read_write(path:pchar; ignore_enoent:svn_boolean_t; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_set_file_read_write';

  {* Similar to svn_io_set_file_read_* functions.
   * Change the read-write permissions of a file.
   * @since New in 1.1.
   *
   * When making @a path read-write on operating systems with unix style
   * permissions, set the permissions on @a path to the permissions that
   * are set when a new file is created (effectively honoring the user's
   * umask).
   *
   * When making the file read-only on operating systems with unix style
   * permissions, remove all write permissions.
   *
   * On other operating systems, toggle the file's "writability" as much as
   * the operating system allows.
   *
   * @a path is the utf8-encoded path to the file.  If @a enable_write
   * is @c TRUE, then make the file read-write.  If @c FALSE, make it
   * read-only.  If @a ignore_enoent is @c TRUE, don't fail if the target
   * file doesn't exist.
   *
   * @deprecated Provided for backward compatibility with the 1.3 API.
    }
  function svn_io_set_file_read_write_carefully(path:pchar; enable_write:svn_boolean_t; ignore_enoent:svn_boolean_t; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_set_file_read_write_carefully';

  {* Toggle a file's "executability".
   *
   * When making the file executable on operating systems with unix style
   * permissions, never add an execute permission where there is not
   * already a read permission: that is, only make the file executable
   * for the user, group or world if the corresponding read permission
   * is already set for user, group or world.
   *
   * When making the file non-executable on operating systems with unix style
   * permissions, remove all execute permissions.
   *
   * On other operating systems, toggle the file's "executability" as much as
   * the operating system allows.
   *
   * @a path is the utf8-encoded path to the file.  If @a executable
   * is @c TRUE, then make the file executable.  If @c FALSE, make it
   * non-executable.  If @a ignore_enoent is @c TRUE, don't fail if the target
   * file doesn't exist.
    }
  function svn_io_set_file_executable(path:pchar; executable:svn_boolean_t; ignore_enoent:svn_boolean_t; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_set_file_executable';

  {* Determine whether a file is executable by the current user.  
   * Set @a *executable to @c TRUE if the file @a path is executable by the 
   * current user, otherwise set it to @c FALSE.  
   * 
   * On Windows and on platforms without userids, always returns @c FALSE.
    }
  function svn_io_is_file_executable(executable:svn_boolean_p; path:pchar; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_is_file_executable';

  {* Read a line from @a file into @a buf, but not exceeding @a *limit bytes.
   * Does not include newline, instead '\\0' is put there.
   * Length (as in strlen) is returned in @a *limit.
   * @a buf should be pre-allocated.
   * @a file should be already opened. 
   *
   * When the file is out of lines, @c APR_EOF will be returned.
    }
  function svn_io_read_length_line(_file:apr_file_p; buf:pchar; limit:papr_size_t; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_read_length_line';

  {* Set @a *apr_time to the time of last modification of the contents of the
   * file @a path.  @a path is utf8-encoded.
   *
   * @note This is the APR mtime which corresponds to the traditional mtime
   * on Unix, and the last write time on Windows.
    }
  function svn_io_file_affected_time(apr_time:apr_time_p; path:pchar; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_file_affected_time';

  {* Set the timestamp of file @a path to @a apr_time.  @a path is
   *  utf8-encoded.
   *
   * @note This is the APR mtime which corresponds to the traditional mtime
   * on Unix, and the last write time on Windows.
    }
  function svn_io_set_file_affected_time(apr_time:apr_time_t; path:pchar; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_set_file_affected_time';

  {* Set @a *different_p to non-zero if @a file1 and @a file2 have different
   * sizes, else set to zero.  Both @a file1 and @a file2 are utf8-encoded.
   *
   * Setting @a *different_p to zero does not mean the files definitely
   * have the same size, it merely means that the sizes are not
   * definitely different.  That is, if the size of one or both files
   * cannot be determined, then the sizes are not known to be different,
   * so @a *different_p is set to 0.
    }
  function svn_io_filesizes_different_p(different_p:svn_boolean_p; file1:pchar; file2:pchar; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_filesizes_different_p';

  {* Put the md5 checksum of @a file into @a digest.
   * @a digest points to @c APR_MD5_DIGESTSIZE bytes of storage.
   * Use @a pool only for temporary allocations.
    }
  function svn_io_file_checksum(digest:array of byte; _file:pchar; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_file_checksum';

  {* Set @a *same to TRUE if @a file1 and @a file2 have the same
   * contents, else set it to FALSE.  Use @a pool for temporary allocations.
    }
  function svn_io_files_contents_same_p(same:svn_boolean_p; file1:pchar; file2:pchar; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_files_contents_same_p';

  {* Create file at @a file with contents @a contents.
   * will be created.  Path @a file is utf8-encoded.
   * Use @a pool for memory allocations.
    }
  function svn_io_file_create(_file:pchar; contents:pchar; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_file_create';

  {*
   * Lock file at @a lock_file. If @a exclusive is TRUE,
   * obtain exclusive lock, otherwise obtain shared lock.
   * Lock will be automatically released when @a pool is cleared or destroyed.
   * Use @a pool for memory allocations.
   *
   * @deprecated Provided for backward compatibility with the 1.0 API.
    }
  function svn_io_file_lock(lock_file:pchar; exclusive:svn_boolean_t; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_file_lock';

  {*
   * Lock file at @a lock_file. If @a exclusive is TRUE,
   * obtain exclusive lock, otherwise obtain shared lock.
   *
   * If @a nonblocking is TRUE, do not wait for the lock if it
   * is not available: throw an error instead.
   *
   * Lock will be automatically released when @a pool is cleared or destroyed.
   * Use @a pool for memory allocations.
   *
   * @since New in 1.1.
    }
  function svn_io_file_lock2(lock_file:pchar; exclusive:svn_boolean_t; nonblocking:svn_boolean_t; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_file_lock2';

  {*
   * Flush any unwritten data from @a file to disk.  Use @a pool for
   *  memory allocations.
   *
   * @since New in 1.1.
    }
  function svn_io_file_flush_to_disk(_file:apr_file_p; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_file_flush_to_disk';

  {* Copy file @a file from location @a src_path to location @a dest_path.
   * Use @a pool for memory allocations.
    }
  function svn_io_dir_file_copy(src_path:pchar; dest_path:pchar; _file:pchar; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_dir_file_copy';

  {* Generic byte-streams
   *
   * @defgroup svn_io_byte_streams generic byte streams
   * @
    }
  {* An abstract stream of bytes--either incoming or outgoing or both.
   *
   * The creator of a stream sets functions to handle read and write.
   * Both of these handlers accept a baton whose value is determined at
   * stream creation time; this baton can point to a structure
   * containing data associated with the stream.  If a caller attempts
   * to invoke a handler which has not been set, it will generate a
   * runtime assertion failure.  The creator can also set a handler for
   * close requests so that it can flush buffered data or whatever;
   * if a close handler is not specified, a close request on the stream
   * will simply be ignored.  Note that svn_stream_close() does not
   * deallocate the memory used to allocate the stream structure; free
   * the pool you created the stream in to free that memory.
   *
   * The read and write handlers accept length arguments via pointer.
   * On entry to the handler, the pointed-to value should be the amount
   * of data which can be read or the amount of data to write.  When the
   * handler returns, the value is reset to the amount of data actually
   * read or written.  Handlers are obliged to complete a read or write
   * to the maximum extent possible; thus, a short read with no
   * associated error implies the end of the input stream, and a short
   * write should never occur without an associated error.
    }

type
(** Read handler function for a generic stream.  @see svn_stream_t. *)
     psvn_read_fn_t = ^svn_read_fn_t;
     svn_read_fn_t = function (
       baton: pointer;
       buffer: pchar;
       var len: apr_size_t
     ): svn_error_p; cdecl;

(** Write handler function for a generic stream.  @see svn_stream_t. *)
     svn_write_fn_p = ^svn_write_fn_t;
     svn_write_fn_t = function (
       baton: pointer;
       data: pchar;
       var len: apr_size_t
     ): svn_error_p; cdecl;

(** Close handler function for a generic stream.  @see svn_stream_t. *)
     psvn_close_fn_t = ^svn_close_fn_t;
     svn_close_fn_p = ^svn_error_t;
     svn_close_fn_t = function (baton: pointer): svn_error_p; cdecl;

(** Create a generic stream.  @see svn_stream_t. *)
function svn_stream_create(baton: pointer; pool: apr_pool_p): svn_stream_p; cdecl; external libsvn_subr name 'svn_stream_create';

{* Set @a stream's baton to @a baton  }
procedure svn_stream_set_baton(stream:svn_stream_p; baton:pointer); cdecl; external libsvn_subr name 'svn_stream_set_baton';

{* Set @a stream's read function to @a read_fn  }
procedure svn_stream_set_read(stream:svn_stream_p; read_fn:svn_read_fn_t); cdecl; external libsvn_subr name 'svn_stream_set_read';

{* Set @a stream's write function to @a write_fn  }
procedure svn_stream_set_write(stream: svn_stream_p; write_fn: svn_write_fn_t); cdecl; external libsvn_subr name 'svn_stream_set_write';

{* Set @a stream's close function to @a close_fn  }
procedure svn_stream_set_close(stream:svn_stream_p; close_fn:svn_close_fn_t); cdecl; external libsvn_subr name 'svn_stream_set_close';

{* Create a stream that is empty for reading and infinite for writing.  }
function svn_stream_empty(pool:apr_pool_p):svn_stream_p; cdecl; external libsvn_subr name 'svn_stream_empty';

  {* Return a stream allocated in @a pool which forwards all requests
   * to @a stream.  Destruction is explicitly excluded from forwarding.
   *
   * @see notes/destruction-of-stacked-resources
   *
   * @since New in 1.4.
    }
  function svn_stream_disown(stream:svn_stream_p; pool:apr_pool_p):svn_stream_p; cdecl; external libsvn_subr name 'svn_stream_disown';

  {* Create a stream from an APR file.  For convenience, if @a file is
   * @c NULL, an empty stream created by svn_stream_empty() is returned.
   *
   * This function should normally be called with @a disown set to false,
   * in which case closing the stream will also close the underlying file.
   *
   * If @a disown is true, the stream will disown the underlying file,
   * meaning that svn_stream_close() will not close the file.
   *
   * @since New in 1.4.
    }
  function svn_stream_from_aprfile2(_file:apr_file_p; disown:svn_boolean_t; pool:apr_pool_p):svn_stream_p; cdecl; external libsvn_subr name 'svn_stream_from_aprfile2';

  {* Similar to svn_stream_from_aprfile2(), except that the file will
   * always be disowned.
   *
   * @note The stream returned is not considered to "own" the underlying
   *       file, meaning that svn_stream_close() on the stream will not
   *       close the file.
   *
   * @deprecated Provided for backward compatibility with the 1.3 API.
    }
  function svn_stream_from_aprfile(_file:apr_file_p; pool:apr_pool_p):svn_stream_p; cdecl; external libsvn_subr name 'svn_stream_from_aprfile';

  {* Set @a *out to a generic stream connected to stdout, allocated in 
   * @a pool.  The stream and its underlying APR handle will be closed
   * when @a pool is cleared or destroyed.
    }
  function svn_stream_for_stdout(out _out: svn_stream_p; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_stream_for_stdout';

  {* Return a generic stream connected to stringbuf @a str.  Allocate the
   * stream in @a pool.
    }
  function svn_stream_from_stringbuf(str:psvn_stringbuf_t; pool:apr_pool_p):svn_stream_p; cdecl; external libsvn_subr name 'svn_stream_from_stringbuf';

  {* Return a stream that decompresses all data read and compresses all
   * data written. The stream @a stream is used to read and write all
   * compressed data. All compression data structures are allocated on
   * @a pool. If compression support is not compiled in then
   * svn_stream_compressed() returns @a stream unmodified. Make sure you
   * call svn_stream_close() on the stream returned by this function,
   * so that all data are flushed and cleaned up.
    }
  function svn_stream_compressed(stream:svn_stream_p; pool:apr_pool_p):svn_stream_p; cdecl; external libsvn_subr name 'svn_stream_compressed';

  {* Return a stream that calculates checksums for all data read
   * and written.  The stream @a stream is used to read and write all data.
   * The stream and the resulting digests are allocated in @a pool.
   *
   * When the stream is closed, @a read_digest and @a write_digest
   * are set to point to the resulting digests.
   *
   * Both @a read_digest and @a write_digest
   * can be @c NULL, in which case the respective checksum isn't calculated.
   *
   * If @a read_all is true, make sure that all data available on @a
   * stream is read (and checksummed) when the stream is closed.
   *
   * Read and write operations can be mixed without interfering.
   *
   * The @a stream passed into this function is closed when the created
   * stream is closed.
   *
   * @since New in 1.4.
    }
(* Const before type ignored *)
(* Const before type ignored *)
  function svn_stream_checksummed(stream:svn_stream_p; read_digest:ppbyte; write_digest:Ppbyte; read_all:svn_boolean_t; pool:apr_pool_p):svn_stream_p; cdecl; external libsvn_subr name 'svn_stream_checksummed';

  {* Read from a generic stream. @see svn_stream_t.  }
  function svn_stream_read(stream:svn_stream_p; buffer:pchar; len:papr_size_t):svn_error_p; cdecl; external libsvn_subr name 'svn_stream_read';

  {* Write to a generic stream. @see svn_stream_t.  }
(* Const before type ignored *)
  function svn_stream_write(stream:svn_stream_p; data:pchar; len:papr_size_t):svn_error_p; cdecl; external libsvn_subr name 'svn_stream_write';

  {* Close a generic stream. @see svn_stream_t.  }
  function svn_stream_close(stream:svn_stream_p):svn_error_p; cdecl; external libsvn_subr name 'svn_stream_close';


  {* Allocate @a *stringbuf in @a pool, and read into it one line (terminated
   * by @a eol) from @a stream. The line-terminator is read from the stream,
   * but is not added to the end of the stringbuf.  Instead, the stringbuf
   * ends with a usual '\\0'.
   *
   * If @a stream runs out of bytes before encountering a line-terminator,
   * then set @a *eof to @c TRUE, otherwise set @a *eof to FALSE.
    }
  function svn_stream_readline(stream:svn_stream_p; out stringbuf: svn_stringbuf_p; eol:pchar; eof:svn_boolean_p; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_stream_readline';

  {*
   * Read the contents of the readable stream @a from and write them to the
   * writable stream @a to.
   *
   * @since New in 1.1.
    }
  function svn_stream_copy(from:svn_stream_p; _to:svn_stream_p; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_stream_copy';

  {* Set @a *same to TRUE if @a stream1 and @a stream2 have the same
   * contents, else set it to FALSE.  Use @a pool for temporary allocations.
   *
   * @since New in 1.4.
    }
  function svn_stream_contents_same(same:svn_boolean_p; stream1:svn_stream_p; stream2:svn_stream_p; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_stream_contents_same';

  {* @  }
  {* Sets @a *result to a string containing the contents of @a filename, a
   * utf8-encoded path. 
   *
   * If @a filename is "-", return the error @c SVN_ERR_UNSUPPORTED_FEATURE
   * and don't touch @a *result.
   *
   * ### Someday, "-" will fill @a *result from stdin.  The problem right
   * now is that if the same command invokes the editor, stdin is crap,
   * and the editor acts funny or dies outright.  One solution is to
   * disallow stdin reading and invoking the editor, but how to do that
   * reliably?
    }
  function svn_stringbuf_from_file(out result: svn_stringbuf_p; filename:pchar; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_stringbuf_from_file';

  {* Sets @a *result to a string containing the contents of the already opened
   * @a file.  Reads from the current position in file to the end.  Does not
   * close the file or reset the cursor position.
    }
  function svn_stringbuf_from_aprfile(out result: svn_stringbuf_p; _file:apr_file_p; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_stringbuf_from_aprfile';

  {* Remove file @a path, a utf8-encoded path.  This wraps apr_file_remove(), 
   * converting any error to a Subversion error.
    }
  function svn_io_remove_file(path:pchar; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_remove_file';

  {* Recursively remove directory @a path.  @a path is utf8-encoded.  }
  function svn_io_remove_dir(path:pchar; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_remove_dir';

  {* Read all of the disk entries in directory @a path, a utf8-encoded
   * path.  Set @a *dirents to a hash mapping dirent names (<tt>char *</tt>) to
   * undefined non-NULL values, allocated in @a pool.
   *
   * @note The `.' and `..' directories normally returned by
   * apr_dir_read() are NOT returned in the hash.
   *
   * @since New in 1.4.
    }
  function svn_io_get_dir_filenames(out dirents: apr_hash_p; path:pchar; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_get_dir_filenames';

  {* Read all of the disk entries in directory @a path, a utf8-encoded
   * path.  Set @a *dirents to a hash mapping dirent names (<tt>char *</tt>) to
   * @c svn_io_dirent_t structures, allocated in @a pool.
   *
   * @note The `.' and `..' directories normally returned by
   * apr_dir_read() are NOT returned in the hash.
   *
   * @since New in 1.3.
    }
  function svn_io_get_dirents2(out dirents: apr_hash_p; path:pchar; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_get_dirents2';

  {* Similar to svn_io_get_dirents2(), but @a *dirents is a hash table
   * with @c svn_node_kind_t values.
   *
   * @deprecated Provided for backwards compatibility with the 1.2 API.
    }
  function svn_io_get_dirents(out dirents: apr_hash_p; path:pchar; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_get_dirents';

  {* Callback function type for svn_io_dir_walk()  }
type
  svn_io_walk_func_p = ^svn_io_walk_func_t;
  svn_io_walk_func_t = function (
    baton: pointer;
    path: pchar;
    finfo: apr_finfo_p;
    pool: apr_pool_p
  ): svn_error_p; cdecl;

  {* This function will recursively walk over the files and directories
   * rooted at @a dirname, a utf8-encoded path. For each file or directory,
   * @a walk_func is invoked, passing in the @a walk_baton, the utf8-encoded
   * full path to the entry, an @c apr_finfo_t structure, and a temporary
   * pool for allocations.  For any directory, @a walk_func will be invoked
   * on the directory itself before being invoked on any subdirectories or
   * files within the directory.
   *
   * The set of information passed to @a walk_func is specified by @a wanted,
   * and the items specified by @c APR_FINFO_TYPE and @c APR_FINFO_NAME.
   *
   * All allocations will be performed in @a pool.
    }
  function svn_io_dir_walk(dirname:pchar; wanted:apr_int32_t; walk_func:svn_io_walk_func_t; walk_baton:pointer; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_dir_walk';

  {*
   * Start @a cmd with @a args, using utf8-encoded @a path as working 
   * directory.  Connect @a cmd's stdin, stdout, and stderr to @a infile, 
   * @a outfile, and @a errfile, except where they are null.  Return the
   * process handle for the invoked program in @a *cmd_proc.
   *
   * @a args is a list of utf8-encoded <tt>const char *</tt> arguments,
   * terminated by @c NULL.  @a args[0] is the name of the program, though it
   * need not be the same as @a cmd.
   *
   * If @a inherit is true, the invoked program inherits its environment from
   * the caller and @a cmd, if not absolute, is searched for in PATH.
   * Otherwise, the invoked program runs with an empty environment and @a cmd
   * must be an absolute path.
   *
   * @note On some platforms, failure to execute @a cmd in the child process
   * will result in error output being written to @a errfile, if non-NULL, and
   * a non-zero exit status being returned to the parent process.
   *
   * @since New in 1.3.
    }
  // TODO Identifier not found "apr_proc_p"
  //function svn_io_start_cmd(cmd_proc:apr_proc_p; path:pchar; cmd:pchar; args:Ppchar; inherit:svn_boolean_t; 
  //           infile:apr_file_p; outfile:apr_file_p; errfile:apr_file_p; pool:apr_pool_p):svn_error_p;

  {*
   * Wait for the process @a *cmd_proc to complete and optionally retrieve
   * its exit code.  @a cmd is used only in error messages.
   *
   * If @a exitcode is not null, @a *exitcode will contain the exit code
   * of the process upon return, and if @a exitwhy is not null, @a
   * *exitwhy will indicate why the process terminated.  If @a exitwhy is 
   * null, and the exit reason is not @c APR_PROC_CHECK_EXIT(), or if 
   * @a exitcode is null and the exit code is non-zero, then an
   * @c SVN_ERR_EXTERNAL_PROGRAM error will be returned.
   *
   * @since New in 1.3.
    }
  // TODO Identifier not found "apr_proc_p"
  //function svn_io_wait_for_cmd(cmd_proc:apr_proc_p; cmd:pchar; exitcode:plongint; out exitwhy:apr_exit_why_e; pool:apr_pool_p):svn_error_p;

  {* Run a command to completion, by first calling svn_io_start_cmd() and
   * then calling svn_io_wait_for_cmd().  The parameters correspond to
   * the same-named parameters of those two functions.
    }
  // TODO Identifier not found "apr_exit_why_e"
  //function svn_io_run_cmd(path:pchar; cmd:pchar; args:Ppchar; exitcode:plongint; out exitwhy: apr_exit_why_e; 
  //           inherit:svn_boolean_t; infile:apr_file_p; outfile:apr_file_p; errfile:apr_file_p; pool:apr_pool_p):svn_error_p;

  {* Invoke @c the configured diff program, with @a user_args (an array
   * of utf8-encoded @a num_user_args arguments), if they are specified,
   * or "-u" if they are not.
   *
   * Diff runs in utf8-encoded @a dir, and its exit status is stored in
   * @a exitcode, if it is not @c NULL.  
   *
   * If @a label1 and/or @a label2 are not null they will be passed to the diff
   * process as the arguments of "-L" options.  @a label1 and @a label2 are also 
   * in utf8, and will be converted to native charset along with the other args.
   *
   * @a from is the first file passed to diff, and @a to is the second.  The
   * stdout of diff will be sent to @a outfile, and the stderr to @a errfile.
   *
   * @a diff_cmd must be non-null.
   *
   * Do all allocation in @a pool. 
    }
  function svn_io_run_diff(dir:pchar; user_args:Ppchar; num_user_args:longint; label1:pchar; label2:pchar; 
             from:pchar; _to:pchar; exitcode:plongint; outfile:apr_file_p; errfile:apr_file_p; 
             diff_cmd:pchar; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_run_diff';

  {* Invoke @c the configured diff3 program, in utf8-encoded @a dir
   * like this:
   *
   *          diff3 -E -m @a mine @a older @a yours > @a merged
   *
   * (See the diff3 documentation for details.)
   *
   * If @a user_args is non-NULL, replace "-E" with the <tt>const char*</tt>
   * elements that @a user_args contains.
   *
   * @a mine, @a older, and @a yours are utf8-encoded paths, relative to @a dir, 
   * to three files that already exist.  @a merged is an open file handle, and
   * is left open after the merge result is written to it. (@a merged
   * should *not* be the same file as @a mine, or nondeterministic things
   * may happen!)
   *
   * @a mine_label, @a older_label, @a yours_label are utf8-encoded label
   * parameters for diff3's -L option.  Any of them may be @c NULL, in
   * which case the corresponding @a mine, @a older, or @a yours parameter is
   * used instead.
   *
   * Set @a *exitcode to diff3's exit status.  If @a *exitcode is anything
   * other than 0 or 1, then return @c SVN_ERR_EXTERNAL_PROGRAM.  (Note the
   * following from the diff3 info pages: "An exit status of 0 means
   * `diff3' was successful, 1 means some conflicts were found, and 2
   * means trouble.") 
   *
   * @a diff3_cmd must be non-null.
   *
   * Do all allocation in @a pool.
   *
   * @since New in 1.4.
    }
  function svn_io_run_diff3_2(exitcode:plongint; dir:pchar; mine:pchar; older:pchar; yours:pchar; 
             mine_label:pchar; older_label:pchar; yours_label:pchar; merged:apr_file_p; diff3_cmd:pchar; 
             user_args: apr_array_header_t; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_run_diff3_2';

  {* Similar to @a svn_io_run_diff3_2(), but with @a user_args set to @c NULL.
   *
   * @deprecated Provided for backwards compatibility with the 1.3 API.
    }
  function svn_io_run_diff3(dir:pchar; mine:pchar; older:pchar; yours:pchar; mine_label:pchar; 
             older_label:pchar; yours_label:pchar; merged:apr_file_p; exitcode:plongint; diff3_cmd:pchar; 
             pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_run_diff3';

  {* Examine utf8-encoded @a file to determine if it can be described by a
   * known (as in, known by this function) Multipurpose Internet Mail
   * Extension (MIME) type.  If so, set @a *mimetype to a character string
   * describing the MIME type, else set it to @c NULL.  Use @a pool for any
   * necessary allocations.
    }
  function svn_io_detect_mimetype(mimetype:Ppchar; _file:pchar; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_detect_mimetype';

  {* Wrapper for apr_file_open(), which see.  @a fname is utf8-encoded.  }
  function svn_io_file_open(out new_file: apr_file_p; fname:pchar; flag:apr_int32_t; perm:apr_fileperms_t; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_file_open';

  {* Wrapper for apr_file_close(), which see.  }
  function svn_io_file_close(_file:apr_file_p; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_file_close';

  {* Wrapper for apr_file_getc(), which see.  }
  function svn_io_file_getc(ch:pchar; _file:apr_file_p; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_file_getc';

  {* Wrapper for apr_file_info_get(), which see.  }
  function svn_io_file_info_get(finfo:apr_finfo_p; wanted:apr_int32_t; _file:apr_file_p; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_file_info_get';

  {* Wrapper for apr_file_read(), which see.  }
  function svn_io_file_read(_file:apr_file_p; buf:pointer; nbytes:papr_size_t; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_file_read';

  {* Wrapper for apr_file_read_full(), which see.  }
  function svn_io_file_read_full(_file:apr_file_p; buf:pointer; nbytes:apr_size_t; bytes_read:papr_size_t; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_file_read_full';

  {* Wrapper for apr_file_seek(), which see.  }
  // TODO Identifier not found "apr_seek_where_t" (apr_file_io.h)
  //function svn_io_file_seek(_file:apr_file_p; where:apr_seek_where_t; offset:papr_off_t; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name '';

  {* Wrapper for apr_file_write(), which see.  }
  function svn_io_file_write(_file:apr_file_p; buf:pointer; nbytes:papr_size_t; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_file_write';

  {* Wrapper for apr_file_write_full(), which see.  }
  function svn_io_file_write_full(_file:apr_file_p; buf:pointer; nbytes:apr_size_t; bytes_written:papr_size_t; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_file_write_full';

  {* Wrapper for apr_stat(), which see.  @a fname is utf8-encoded.  }
  function svn_io_stat(finfo:apr_finfo_p; fname:pchar; wanted:apr_int32_t; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_stat';

  {* Wrapper for apr_file_rename(), which see.  @a from_path and @a to_path
   * are utf8-encoded.
    }
  function svn_io_file_rename(from_path:pchar; to_path:pchar; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_file_rename';

  {* Move the file from @a from_path to @a to_path, even across device
   * boundaries. Overwrite @a to_path if it exists.
   *
   * @note This function is different from svn_io_file_rename in that the
   * latter fails in the 'across device boundaries' case.
   *
   * @since New in 1.3.
    }
  function svn_io_file_move(from_path:pchar; to_path:pchar; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_file_move';

  {* Wrapper for apr_dir_make(), which see.  @a path is utf8-encoded.  }
  function svn_io_dir_make(path:pchar; perm:apr_fileperms_t; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_dir_make';

  {* Same as svn_io_dir_make(), but sets the hidden attribute on the
      directory on systems that support it.  }
  function svn_io_dir_make_hidden(path:pchar; perm:apr_fileperms_t; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_dir_make_hidden';

  {*
   * Same as svn_io_dir_make(), but attempts to set the sgid on the
   * directory on systems that support it.  Does not return an error if
   * the attempt to set the sgid bit fails.  On Unix filesystems,
   * setting the sgid bit on a directory ensures that files and
   * subdirectories created within inherit group ownership from the
   * parent instead of from the primary gid.
   *
   * @since New in 1.1.
    }
  function svn_io_dir_make_sgid(path:pchar; perm:apr_fileperms_t; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_dir_make_sgid';

  {* Wrapper for apr_dir_open(), which see.  @a dirname is utf8-encoded.  }
  function svn_io_dir_open(out new_dir: apr_dir_p; dirname:pchar; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_dir_open';

  {* Wrapper for apr_dir_remove(), which see.  @a dirname is utf8-encoded.
   * @note This function has this name to avoid confusion with
   * svn_io_remove_dir(), which is recursive.
    }
  function svn_io_dir_remove_nonrecursive(dirname:pchar; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_dir_remove_nonrecursive';

  {* Wrapper for apr_dir_read().  Ensures that @a finfo->name is
   * utf8-encoded, which means allocating @a finfo->name in @a pool,
   * which may or may not be the same as @a finfo's pool.  Use @a pool
   * for error allocation as well.
    }
  function svn_io_dir_read(finfo:apr_finfo_p; wanted:apr_int32_t; thedir: apr_dir_p; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_dir_read';

  {* Version/format files. 
   *
   * @defgroup svn_io_format_files version/format files
   * @
    }
  {* Set @a *version to the integer that starts the file at @a path.  If the
   * file does not begin with a series of digits followed by a newline,
   * return the error @c SVN_ERR_BAD_VERSION_FILE_FORMAT.  Use @a pool for
   * all allocations.
    }
  function svn_io_read_version_file(version:plongint; path:pchar; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_read_version_file';

  {* Create (or overwrite) the file at @a path with new contents,
   * formatted as a non-negative integer @a version followed by a single
   * newline.  On successful completion the file will be read-only.  Use
   * @a pool for all allocations.
    }
  function svn_io_write_version_file(path:pchar; version:longint; pool:apr_pool_p):svn_error_p; cdecl; external libsvn_subr name 'svn_io_write_version_file';
