unit mxsvnex;


{$mode objfpc}
{$longstrings on}
{$assertions on}

(******************************************************************************
  mxsvnex.pas

  Pascal extensions for Subversion Client API

  Zolotov Alex, 2007-2008
  zolotov-alex@shamangrad.net
  http://shamangrad.net/

 *****************************************************************************)

interface
uses mxapr, mxsvn, Classes;

function mxsvn_client_cat_to_stream(stream: TStream; const path_or_url: string;
    peg_revision: svn_opt_revision_p; revision: svn_opt_revision_p;
    ctx: svn_client_ctx_p; pool: apr_pool_p): svn_error_p;

implementation

function stream_write(stream: pointer; data: pchar; var len: apr_size_t): svn_error_p; cdecl;
begin
  len := TStream(stream).write(data^, len);
  Result := nil;
end;

function mxsvn_client_cat_to_stream(stream: TStream; const path_or_url: string;
    peg_revision: svn_opt_revision_p; revision: svn_opt_revision_p;
    ctx: svn_client_ctx_p; pool: apr_pool_p): svn_error_p;
var
  subpool: apr_pool_p;
  svn_stream: svn_stream_p;
begin
  assert(stream <> nil);
  assert(apr_pool_create_ex(subpool, pool, nil, nil) = 0);
  svn_stream := svn_stream_create(stream, subpool);
  svn_stream_set_write(svn_stream, @stream_write);
  Result := svn_client_cat2(svn_stream, pchar(path_or_url), peg_revision, revision, ctx, subpool);
  apr_pool_destroy(subpool);
end;

end.
