program mxsvncatex;

{$mode objfpc}
{$longstrings on}
{$assertions on}

uses
  SysUtils, Classes, mxapr, mxsvn, mxsvnex;

var
  allocator: apr_allocator_p;
  pool: apr_pool_p;
  err: svn_error_p;
  ctx: svn_client_ctx_p;
  rev: svn_opt_revision_t;
  ab: psvn_auth_baton_t;
  cfg: svn_config_p;
  URL: string;
  stream: TStringStream;

function cancel_func(cancel_baton: pointer): svn_error_p; cdecl;
begin
  writeln('.');
  Result := nil;
end;

begin
  if ParamCount = 0 then
  begin
    writeln('svnls URL');
    Exit;
  end; // if
  URL := ParamStr(1);
  
  svn_cmdline_init('svnls', nil);
  pool := svn_pool_create(nil);
  
  assert(apr_allocator_create(allocator) = 0);
  assert(allocator <> nil);
  
  apr_allocator_max_free_set(allocator, SVN_ALLOCATOR_RECOMMENDED_MAX_FREE);
  
  pool := svn_pool_create_ex(nil, allocator);
  assert(pool <> nil);
  apr_allocator_owner_set(allocator, pool);
  
  err := svn_config_ensure(nil, pool);
  assert(err = nil);
  
  err := svn_client_create_context(ctx, pool);
  assert(err = nil);
  
  err := svn_config_get_config(ctx^.config, nil, pool);
  assert(err = nil);
  
  cfg := apr_hash_get(ctx^.config, pchar(SVN_CONFIG_CATEGORY_CONFIG),
                     APR_HASH_KEY_STRING);

  
  ctx^.cancel_func := @cancel_func;
  
  err := svn_cmdline_setup_auth_baton(ab,
                                          true,
                                          nil,
                                          nil,
                                          nil,
                                          true,
                                          cfg,
                                          ctx^.cancel_func,
                                          ctx^.cancel_baton,
                                          pool);
  assert(err = nil);
  
  ctx^.auth_baton := ab;
  
  rev.kind := svn_opt_revision_head;
  stream := TStringStream.Create('');
  try
    err := mxsvn_client_cat_to_stream(stream, URL, @rev, @rev, ctx, pool);
    if err <> nil then
    begin
      writeln(stderr, err^.message);
    end; // if
    assert(err = nil);
    writeln('content: ');
    writeln(stream.DataString);
    writeln('----------------');
  finally
    stream.Free;
  end;
  
  svn_pool_destroy(pool);
end.
