program svnls;

{$mode objfpc}
{$longstrings on}
{$assertions on}

uses
  mxapr, mxsvn;

var
  URL: string;
  pool: apr_pool_p;
  err: svn_error_p;
  ctx: svn_client_ctx_p;
  rev: svn_opt_revision_t;
  
function receiver(baton: pointer; path: pchar; info: svn_info_p; pool: apr_pool_p): svn_error_p; cdecl;
begin
  writeln('Path: ', path);
  writeln('URL: ', info^.URL);
  writeln('REV: ', info^.rev);
  writeln('Root: ', info^.repos_root_URL);
  writeln('UUID: ', info^.repos_UUID);
  writeln('LastChangedRev: ', info^.last_changed_rev);
  Result := nil;
end;

function list_func(baton: pointer; path: pchar; dirent: svn_dirent_p; lock: svn_lock_p;
  abs_path: pchar; pool: apr_pool_p): svn_error_p; cdecl;
begin
  writeln(path);
  rev.kind := svn_opt_revision_head;
  err := svn_client_info(pchar(URL), @rev, @rev, @receiver, nil, false, ctx, pool);
  assert(err = nil);
  writeln('---------------------');
  Result := nil;
end;

begin
  if ParamCount = 0 then
  begin
    writeln('svnlist URL');
    Exit;
  end; // if
  URL := ParamStr(1);
  
  svn_cmdline_init('svnlist', nil);
  pool := svn_pool_create(nil);
  assert(pool <> nil);
  
  err := svn_config_ensure(nil, pool);
  assert(err = nil);
  
  err := svn_client_create_context(ctx, pool);
  assert(err = nil);
  
  rev.kind := svn_opt_revision_unspecified;
  err := svn_client_list(pchar(URL), @rev, @rev, false, SVN_DIRENT_ALL,
             false, @list_func, nil, ctx, pool);
  assert(err = nil);
  
  svn_pool_destroy(pool);
end.
